Package: knotR
Type: Package
Title: Knot Diagrams using Bezier Curves
Version: 1.0-4
Authors@R: person(given=c("Robin", "K. S."), family="Hankin", role = c("aut","cre"), email="hankin.robin@gmail.com", comment = c(ORCID = "0000-0001-5982-0415"))
Depends: R (>= 2.10)
Maintainer: Robin K. S. Hankin <hankin.robin@gmail.com>
LazyData: TRUE
Description: Makes visually pleasing diagrams of knot projections using optimized Bezier curves.
License: GPL-2
NeedsCompilation: no
Packaged: 2024-01-22 19:56:20 UTC; rhankin
Author: Robin K. S. Hankin [aut, cre] (<https://orcid.org/0000-0001-5982-0415>)
Repository: CRAN
Date/Publication: 2024-01-24 08:50:02 UTC
Built: R 4.3.3; ; 2025-01-24 09:01:20 UTC; unix

exportPattern("^[[:alpha:]]+")

importFrom("graphics", "par", "plot", "points", "segments", "text")
importFrom("stats", "constrOptim", "integrate", "runif", "uniroot", "nlm","var","optim")

importFrom("utils", "head", "tail")



S3method("head", "inkscape")
S3method("tail", "inkscape")

File jma_knot.tex is to be sent (eventually) to "Journal of
Mathematics and the Arts".  It needs various latex style files
provided by bjourdoc.zip, available at the journal website.  It also
needs image files, PDF and PNG files, that are either:

- stored in the vignettes/ directory
- created by R CMD Sweave knot.Rnw from the commandline (make sure you are in the vignettes/
directory)
- created by inst/knotter.R

So, for the JMA paper, the only files under version control are
jma_knot.tex and knotter.R; the other files are elsewhere.

library(knotR)
filename <- "8_15.svg"
a <- reader(filename)
#knotplot2(a,node=T)

Mver <- matrix(c(
    5,19,
    4,20,
    18,6,
    7,17,
    11,13,
    10,14,
    3,1,
    8,16,
    9,15
),ncol=2,byrow=TRUE)

sym815 <- symmetry_object(a,Mver=Mver,xver=c(2,12))
a <- symmetrize(a,sym815)
#knotplot2(a,node=T)
#knotplot2(a,lwd=1,text=TRUE,rainbow=TRUE,circ=0)


ou815 <- matrix(c(
    19,6,
    14,1,
    2,16,
    9,3,
    4,11,
    7,18,
    12,8,
    17,13
),ncol=2,byrow=TRUE)

#knotplot(a,ou815)


jj <-
  knotoptim(filename,
            symobj = sym815,
            ou   = ou815,
            prob = 0,
            iterlim=1000,print.level=2,hessian=FALSE
#                control=list(trace=100,maxit=10000), useNLM=FALSE
)


write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "7_5.svg"
a <- reader(filename)

Mver <-
    matrix(
        c(13,02,
          12,03,
          01,14,
          11,04,
          19,15,
          18,16,
          05,10,
          09,06,
          08,07
          ),
        byrow=TRUE,ncol=2)

ou75 <- matrix(c(
    01,12,
    14,02,
    04,15,
    11,05,
    06,10,
    17,07,
    09,18
    ),byrow=TRUE,ncol=2)

sym75 <- symmetry_object(a, Mver=Mver, xver=17)   # Mrot=NULL by default

jj <- knotoptim(filename,
                symobj = sym75,
                ou   = ou75,
                prob = 0,
                iterlim=100, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "10_61.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mver <-
  matrix(c(
      16,28,
      15,1,
      27,17,
      26,18,
      25,19,
      14,2,
      4,12,
      5,11,
      13,3,
      6,10,
      24,20,
      7,9,
      23,21
  ),ncol=2,byrow=TRUE)

xver <- c(8,22)

sym1061 <- symmetry_object(a, Mver=Mver, xver=xver)
a <- symmetrize(a,sym1061)
#knotplot2(a,lwd=1,circ=FALSE,text=TRUE,rainbow=TRUE)



ou1061 <- matrix(c(
    17,28,
    2,18,
    20,11,
    9,21,
    24,8,
    6,25,
    27,15,
    12,3,
    4,13,
    14,5
),byrow=TRUE,ncol=2)
#knotplot(a,ou1061)

jj <- knotoptim(filename,
                symobj = sym1061,
                ou = ou1061, prob=0,
                iterlim=1000, print.level=2 )


write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_15.svg"

a <- reader(filename)
Mver <- matrix(c(
    24,02,
    12,14,
    11,15,
    23,03,
    04,22,
    21,05,
    06,20,
    07,19,
    10,16,
    17,09,
    08,18
),ncol=2,byrow=TRUE)

sym915 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        xver = c(1,13),
        mcdonalds=FALSE
    )

a <- symmetrize(a,sym915)

ou915  <-
  matrix(c(
      03,14,
      23,04,
      05,22,
      21,06,
      07,11,
      18,09,
      10,17,
      13,24,
      16,20
        ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                symobj  = sym915,
                ou      = ou915,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_21.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

sym821 <- symmetry_object(a,Mver=NULL,xver=4)
a <- symmetrize(a,sym821)
#knotplot2(a)
#knotplot2(a,text=TRUE,lwd=1,circ=FALSE)


ou821 <- matrix(c(
      09,02,
      03,12,
      15,06,
      07,23,
      18,08,
      13,19,
      22,14,
      23,18
),ncol=2,byrow=TRUE)
#knotplot(a,ou821)

jj <-
  knotoptim(filename,
            symobj = sym821,
            ou   = ou821,
            prob = 0,
            iterlim=1000,print.level=2,hessian=FALSE
#                control=list(trace=100,maxit=10000), useNLM=FALSE
                )





write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_22.svg"
a <- reader(filename)


Mver <- matrix(c(
NA,NA
),ncol=2,byrow=TRUE)


sym922 <-
    symmetry_object(
        x    = a,
        Mver = NULL,
        xver = 12
    )


a <- symmetrize(a,sym922)

ou922  <-
    matrix(c(
        01,21,
        18,04,
        06,28,
        11,07,
        08,31,
        30,10,
        27,17,
        15,25,
        23,12
    ),byrow=TRUE,ncol=2)

#knotplot2(a,text=T,lwd=1,width=F)

jj <- knotoptim(filename,
                symobj = sym922,
                ou   = ou922,
                prob=0,
                iterlim=1000,print.level=2
#                control=list(trace=100,maxit=1000), useNLM=FALSE

                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_3_90deg_crossing.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)
#stop()
Mver <- matrix(c(
     10,24,
     23,11,
     9,1,
     8,2,
     12,22,
     21,13,
     14,20,
     15,19,
     7,3,
     16,18,
     6,4
),ncol=2,byrow=TRUE)

sym83 <- symmetry_object(a,Mver=Mver,xver=c(5,17))
a <- symmetrize(a,sym83)
#knotplot2(a,lwd=1,text=TRUE,circ=FALSE,rainbow=TRUE)


ou83 <- matrix(c(
     11,24,
     23,12,
     13,22,
     21,14,
     3,20,
     18,4,
     7,17,
     15,8
),ncol=2,byrow=TRUE)

#knotplot(a,ou83)

w <- c(pot = 1,
      ang = 100,
      ben = 1,
      len = 1,
      mid = 1,
      clo = 1,
      swi = 1,
      con = 1,
      ncn = 1
      )

jj <-
  knotoptim(filename, weights=w,
            symobj = sym83,
            ou   = ou83,
            prob = 0,
            iterlim=1000,print.level=2,hessian=FALSE
#                control=list(trace=100,maxit=1000), # these arguments for optim()
#                useNLM=FALSE
)


write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "9_39.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)


Mver939 <- matrix(c(
    23,01,
    09,15,
    10,14,
    08,16,
    22,02,
    17,07,
    11,13,
    18,06,
    21,03,
    05,19,
    20,04
), byrow=TRUE,ncol=2)

sym939 <- symmetry_object(a,Mver=Mver939,xver=c(12,24))

a <- symmetrize(a,sym939)
#knotplot2(a,lwd=1,text=TRUE,circ=FALSE,rainbow=TRUE)

ou939 <- matrix(c(  # alternating  
    16,02,
    03,14,
    20,05,
    06,19,
    13,07,
    08,17,
    23,09,
    11,22,
    18,12
), byrow=TRUE,ncol=2)

#knotplot(a,ou939)


jj <- knotoptim(filename,
                symobj=sym939,
                ou   = ou939,
                prob=0,
                iterlim=10000, print.level=2
#                control=list(trace=100,maxit=1000), useNLM=FALSE

                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

## This R script plots (a projection of) a trefoil knot assuming that
## the strand is an elastica.  The constraints are: (1), strands cross
## at right angles; the strands exert a couple but no force on one
## another; (2), mirror symmetry about the vertical; (3), threefold
## rotational symmetry.  Constraint #1 implies that the strands are
## arcs of a circle.

## Elementary trigonometry then shows that the radii of the inner and
## outer loops are cosec(pi/12) and sec(pi/12) = sqrt(6)+sqrt(2) and
## sqrt(6)-sqrt(2) respectively.

## NB this file produces trefoil_circles.pdf, which is not production
## quality!  It needs to be tidied up in inkscape before anyone sees
## it.

library("knotR")

`arc` <- function(x,y,r,theta1,theta2,rot=0,center=FALSE, ...){
  n <- 100
  jj <- matrix(c(cos(rot),sin(rot),-sin(rot),cos(rot)),2,2) %*% c(x,y)
  x <- jj[1]
  y <- jj[2] 
  if(center){ points(x,y, ...) } 
  theta <- seq(from=theta1-rot,to=theta2-rot,len=n)
  points(x+r*sin(theta),y+r*cos(theta),type='l',...)
}

small <- 0.05

`f` <- function(angle,...){
  arc(x=0, y=-2-2/sqrt(3), theta1 =   0, theta2 =   pi/12, r=sqrt(6)+sqrt(2), rot=angle,col='red',lwd=17,...)
  arc(x=0, y=+2-2/sqrt(3), theta1 =  0, theta2 = 7*pi/12, r=sqrt(6)-sqrt(2), rot=angle,col='red',lwd=17,...)

  arc(x=0, y=-2-2/sqrt(3), theta1 = pi/12-small, theta2 =   pi/12+small, r=sqrt(6)+sqrt(2), rot=angle,col='blue',lwd=39,...)

  arc(x=0, y=-2-2/sqrt(3), theta1 =    -pi/12, theta2 =   0, r=sqrt(6)+sqrt(2), rot=angle,lwd=17,...)
  arc(x=0, y=+2-2/sqrt(3), theta1 =  -7*pi/12, theta2 = 0, r=sqrt(6)-sqrt(2), rot=angle,lwd=17,...)
}

pdf(file="trefoil_circles.pdf",height=9,width=9)
par(pty='s')
u <- 1.9
plot(NA,type='n',asp=1,xlim=c(-u,u),ylim=c(-u,u),axes=FALSE,xlab='',ylab='')

f(0*pi/3)
f(2*pi/3)
f(4*pi/3)

dev.off()


pdf(file="trefoil_proper.pdf",height=9,width=9)
knotplot(k3_1,lwd=16)
dev.off()

library(knotR)

filename <- "4_1.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)
Mver <- matrix(c(
    2,4,
    11,9,
    1,5,
    6,14,
    7,13,
    12,8
),ncol=2,byrow=TRUE)

sym41 <- symmetry_object(a,Mver=Mver,xver=c(3,10))
a <- symmetrize(a,sym41)
#knotplot2(a)
#knotplot2(a,text=TRUE,lwd=1,rainbow=TRUE,circ=FALSE)
ou41 <-
    matrix(c(
        5,10,
        8,13,
        1,6,
        11,2
),ncol=2,byrow=TRUE)

#knotplot(a,ou41)

jj <- knotoptim(filename,
                symobj = sym41,
                ou   = ou41,
                prob=0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_25.svg"

a <- reader(filename)

Mver925 <- matrix(c(
    10,18,
    17,11,
    12,16,
    13,15,
    06,04,
    07,03,
    08,02
    ),ncol=2,byrow=TRUE)

sym925 <-
    symmetry_object(
        x    = a,
        xver = c(5,14),
        Mver = Mver925,
        mcdonalds=FALSE
    )

a <- symmetrize(a,sym925)

ou925  <-
    matrix(c(
        20,  1,
        2,  22,
        16,  5,
        6,  13,
        27,  9,
        10, 25,
        18, 11,
        12, 17,        
        24, 19
    ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                symobj  = sym925,
                ou      = ou925,
                prob    = 0,
                iterlim = 1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_13.svg"
a <- reader(filename)
Mver <- matrix(c(
    19,10,
    09,18
),ncol=2,byrow=TRUE)


sym913 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        xver = 22,
        mcdonalds=TRUE
        )
    
a <- symmetrize(a,sym913)

ou913  <-
  matrix(c(
      15,01,
      02,13,
      12,04,
      05,16,
      22,05,
      19,10,
      09,18,
      17,08,
      07,21
  ),byrow=TRUE,ncol=2)

jj <- knotoptim(filename,
                symobj  = sym913,
                ou      = ou913,
                prob    = 0,
                iterlim = 1000,print.level=2
#                control=list(trace=100,maxit=1000), useNLM=FALSE
                )



write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_1.svg"
a <- reader(filename)
#knotplot2(a,node=T)

Mver <- matrix(c(
    10,24,
    09,01,
    23,11,
    12,22,
    13,21,
    14,20,
    08,02,
    07,03,
    06,04,
    15,19,
    16,18
),ncol=2,byrow=TRUE)

sym81 <- symmetry_object(a,Mver=Mver,xver=c(5,17))
a <- symmetrize(a,sym81)
#knotplot2(a,node=TRUE)
#knotplot2(a,text=TRUE,lwd=1,rainbow=TRUE,circ=FALSE)



ou81 <- matrix(c(
    02,22,
    20,03,
    05,19,
    16,06,
    08,15,
    13,09,
    23,12,
    11,24
),ncol=2,byrow=TRUE)

#knotplot(a,ou81)

jj <-
  knotoptim(filename,
            symobj = sym81,
            ou   = ou81,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "perko_A.svg"
a <- reader(filename)

ou_perko_A <- matrix(c(
    08,01,
    11,02,
    03,12,
    13,04,
    18,05,
    06,19,
    07,14,
    16,09,
    10,17,
    15,20
    ),byrow=TRUE, ncol=2)
knotplot(a,ou_perko_A)
stop()


## jj <- reader(system.file("perko_B.svg",package="knot"))
jj <- reader("~/packages/rhankin/packages/trunk/knot/inst/perko_B.svg")
sym_perko_B <- symmetry_object(jj, xver=23 )
perko_B <-  symmetrize(as.minobj(jj),sym_perko_B)

knotplot(perko_B,circ=300)

mii <- make_minsymvec_from_minobj(as.minobj(perko_B), sym_perko_B)
pii <- make_minobj_from_minsymvec(mii,sym_perko_B)

knotplot(pii)

## now some optimization:

`fun` <- function(vec){   # objective function
  out <- badness(make_minobj_from_minsymvec(vec,sym_perko_B))
  return(out)
}

o <- nlm(fun,mii,iterlim=1,print.level=2)
knotplot(make_minobj_from_minsymvec(o$estimate,sym_perko_B))

## second round of optimization:
#o2 <- nlm(fun,o$estimate,iterlim=10,print.level=2)

perko_B_ou <- matrix(c(
    16,1,
    2,14,
    3,20,
    12,4,
    18,5,
    6,17,
    7,11,
    22,8,
    10,23,
    19,13),
    byrow=TRUE,ncol=2)


perkoB_opt <- knot(
    x=make_minobj_from_minsymvec(o$estimate,sym_perko_B),
    overunderobj = perko_B_ou,
    xver = 23)

save(perkoB_opt,file="~/optimized_perkoB")

library(knotR)
filename <- "9_18.svg"

a <- reader(filename)
         
Mver <- matrix(c(
    29,01,
    06,04,
    25,23,
    26,22,
    12,14
),ncol=2,byrow=TRUE)

sym918 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        xver = c(5,24,30),
        mcdonalds=FALSE
    )

a <- symmetrize(a,sym918)


ou918  <-
  matrix(c(
      18,02,
      03,20,
      23,05,
      06,26,
      29,09,
      11,28,
      27,13,
      14,22,
      21,16
        ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                symobj  = sym918,
                ou      = ou918,
                prob    = 0,
                iterlim = 9000, print.level=2
#                control=list(trace=100,maxit=1000), # these arguments for optim()
#                useNLM=FALSE
                
                )


write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "9_36.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

#knotplot2(a,lwd=1,text=TRUE,rainbow=TRUE,circ=FALSE)


ou936 <- matrix(c(  # alternating  
    1,26,
    24,2,
    4,12,
    15,5,
    8,16,
    20,9,
    11,23,
    18,29,
    27,19
), byrow=TRUE,ncol=2)

#knotplot(a,ou936)


sym936 <- symmetry_object(a,xver=9)
a <- symmetrize(a,sym936)
##knotplot2(a)
##knotplot2(a,lwd=1,text=TRUE,circ=FALSE,rain=TRUE)
##knotplot(a,ou936)


jj <- knotoptim(filename,
                symobj=sym936,
                ou   = ou936,
                prob=0,
                iterlim=10000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "10_75.svg"
a <- reader(filename)

Mver <-
  matrix(c(
      12,20,
      19,13,
      09,03,
      18,14,
      10,02,
      11,01,
      17,15,
      08,04,
      05,07
  ),ncol=2,byrow=TRUE)

xver <- c(6,16)

ou1075 <- matrix(c(
    1,4,
    15,2,
    3,14,
    5,8,
    17,6,
    7,16,
    9,12,
    19,10,
    11,18,
    13,20
),byrow=TRUE,ncol=2)


sym1075 <- symmetry_object(a, Mver=Mver, xver=xver)
ar <- symmetrize(as.minobj(a),sym1075)
knotplot(ar,ou1075,gap=4)

jj <- knotoptim(filename,
                symobj = sym1075,
                ou = ou1075, 
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "3_1_not_symmetric.svg"
a <- reader(filename)
knotplot2(a,seg=T,text=T,lwd=1,node=T)


         
Mver <- matrix(c(
    08,10,
    07,11,
    02,04,
    01,05,
    12,06
    ),ncol=2,byrow=TRUE)

Mrot <- matrix(c(
    09,05,01,
    10,06,02,
    08,04,12
    ),byrow=TRUE,ncol=3)

ou31 <- matrix(c(
    03,08,
    11,04,
    07,12
    ),byrow=TRUE,ncol=2)



sym31 <- symmetry_object(a, Mver=Mver,xver=c(9,3),Mrot=Mrot)   

knotplot2(symmetrize(a,sym31),seg=T,node=T)

jj <- knotoptim(filename,
                symobj = sym31,
                ou   = ou31,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))


stop() 




## Function symmetrize_LR() creates a symmetrized knot:
k77 <- symmetrize(as.minobj(a), sym77)

knotplot(k77,T,T,T,T,T,circ=500)  #OK, it looks terrible

mii <- make_minsymvec_from_minobj(k77,sym77)
pii <- make_minobj_from_minsymvec(mii,sym77)




knotplot2(k77,ou77)


# now optimize; first define an objective function:

`objective_function` <- function(m){
    badness(make_minobj_from_minsymvec(m, sym77))
}

o <- nlm(objective_function,mii,iterlim=30,print.level=2)

opt77 <-  make_minobj_from_minsymvec(o$estimate,sym77)
knotplot(opt77,T,T,T,T,circ=1900)

library(knotR)
filename <- "reefknot.svg"
a <- reader(filename)


Mhor <- matrix(c(
    17,1,
    16,2,
    18,32,
    15,3,
    19,31,
    24,26,
    23,27,
    14,4,
    22,28,
    13,5,
    22,28,
    12,6,
    21,29,
    11,7,
    20,30,
    10,8,
    19,31,
    18,32
    ),ncol=2,byrow=TRUE)

Mver <- matrix(c(
    16,18,
    23,11,
    22,12,
    24,10,
    15,19,
    3,31,
    14,20,
    13,21,
    3,31,
    25,9,
    4,30,
    5,29,
    26,8,
    27,7,
    28,6,
    2,32
 ),ncol=2,byrow=TRUE)

xver <- c(1,17)
xhor <- c(25,9)

symobjreef <- symmetry_object(a, Mver=Mver,Mhor=Mhor,xver=xver, xhor=xhor,reefknot=TRUE)
a <- symmetrize(a,symobjreef)

oureef <- matrix(c(
    20, 10,
    13, 22,
    25, 15,
    26, 04,
    06, 29,
    31, 09
),ncol=2,byrow=TRUE)


jj <- knotoptim(filename,
                symobj = symobjreef,
                ou   = oureef,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "hexknot2.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

jj <- matrix(1:60,10)

symhex <- symmetry_object(a, Mrot=jj)
a <- symmetrize(a,symhex)
#knotplot2(a,node=T)

#knotplot2(a,lwd=0,circ=F,text=TRUE,rainbow=T,seg=T,xlim=c(-1000,10000))

ouhex <- matrix(c(
  8, 1,
 14, 3,
 2, 16,
 18,11,
 24,13,
 12,26,
 28,21,
 34,23,
 22,36,
 38,31,
 44,33,
 32,46,
 48,41,
 52, 6,
 4, 53,
 54,43,
 42,56,
 58,51
),ncol=2,byrow=TRUE)

#knotplot(a,ouhex,gap=10)



# We will try and request that node 4 is on the vertical centreline.

jj <- knotoptim(filename,
                symobj = symhex,
                ou   = ouhex,
                prob=0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=10000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_7.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

sym87 <- symmetry_object(a,Mver=NULL,xver=8)

ou87 <- matrix(c(
    23,05,
    15,22,
    21,11,
    10,19,
    18,07,
    06,16,
    04,14,
    13,02
),ncol=2,byrow=TRUE)

#knotplot2(a,text=TRUE,lwd=1,circ=FALSE)
#knotplot(symmetrize(a,sym87),ou87)

jj <-
  knotoptim(filename,
            symobj = sym87,
            ou   = ou87,
            prob = 0,
            iterlim = 1000, print.level=2, hessian=FALSE
#            control=list(trace=100,maxit=2000), # these arguments for optim()
#            useNLM=FALSE
            )


write_svg(jj, filename, safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "fiveloops.svg"
a <- reader(filename)

Mrot <- matrix(c(
    16,20,04,08,12,
    17,01,05,09,13,
    15,19,03,07,11,
    06,10,14,18,02
    ),byrow=TRUE,ncol=5)

Mver <- matrix(c(
    17,15,
    11,01,
    12,20,
    13,19,
    14,18,
    10,02,
    07,05,
    08,04,
    09,03
),ncol=2,byrow=TRUE)

symfive <-
    symmetry_object(
        x    = a,
        Mver = Mver,
       Mrot = Mrot,
        xver = c(6,16),
        mcdonalds=FALSE
        )

as <- symmetrize(a,symfive)

#knotplot2(as,node=T,seg=T,width=F)
#knotplot2(as,node=F,lwd=1,width=F,text=T)

oufive  <-
    matrix(c(
        19,02,
        03,06,
        07,10,
        11,14,
        15,18
        ),byrow=TRUE,ncol=2)

jj <- knotoptim(filename,
                symobj = symfive,
                ou   = oufive,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "k11n22.svg"
a <- reader(filename)

#knotplot2(a,node=TRUE,lwd=1,width=0)

Mver <-
  matrix(c(
      19,1,
      20,28,
      21,27,
      13,7,
      26,22,
      18,2,
      14,6,
      15,5,
      17,3,
      25,23,
      16,4,
      11,9
  ),ncol=2,byrow=TRUE)

xver  <- c(10,24)
symk11n <- symmetry_object(a, Mver=Mver, xver=xver)
a  <- symmetrize(as.minobj(a),symk11n)
#knotplot2(a)
#knotplot2(a,lwd=1,text=TRUE,circ=FALSE)

ouk11n <-
  matrix(c(
      22,27,
      3,23,
      24,4,
      25,17,
      18,26,
      2,7,
      8,3,
      5,9,
      12,16,
      18,13,
      14,19
  ),byrow=TRUE,ncol=2)

knotplot(a,ouk11n)


jj <- knotoptim(filename,
                symobj = symk11n,
                ou   = ouk11n,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "satellite.svg"
a <- reader(filename)
#knotplot2(a,lwd=1,text=T,width=F,rainbow=T,seg=T)

ousat <- 
    matrix(c(
        02,23,
        02,40,
        39,04,
        24,05,
        31,06,
        07,30,
        24,08,
        38,09,
        12,41,
        12,22,
        32,15,
        29,15,
        16,27,
        17,35,
        46,26,
        29,47,
        32,48,
        45,36
        ),byrow=TRUE,ncol=2)
symsat <- symmetry_object(x=a, xver=19)

jj <- knotoptim(filename,
                symobj = symsat,
                ou   = ousat,
                prob = 0,
#           iterlim=1000,print.level=2,         # these arguments for nlm()
                control=list(trace=9000,maxit=10000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_21.svg"

a <- reader(filename)

sym921 <-
    symmetry_object(
        x    = a,
        xver = 29,
        mcdonalds=FALSE
    )

a <- symmetrize(a,sym921)


ou921  <-
    matrix(c(
        02,12,
        23,04,
        05,19,
        17,06,
        09,28,
        26,10,
        11,24,
        14,22,
        20,15
        ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                symobj  = sym921,
                ou      = ou921,
                prob    = 0,
                iterlim= 9000, print.level=2
#               control=list(trace=100,maxit=1000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_19.svg"

a <- reader(filename)

sym919 <-
    symmetry_object(
        x    = a,
        xver = 11,
        mcdonalds=FALSE
    )

a <- symmetrize(a,sym919)

ou919  <-
  matrix(c(
      19,24,
      26,10,
      08,27,
      02,07,
      16,03,
      05,15,
      11,18,
      23,12,
      13,21
        ),byrow=TRUE,ncol=2)

jj <- knotoptim(filename,
                symobj  = sym919,
                ou      = ou919,
                prob    = 0,
                iterlim=30, print.level=2
#                control=list(trace=100,maxit=70000), useNLM=FALSE
                )


write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "k11n157_morenodes.svg"
a <- reader(filename)

Mver <-
  matrix(c(
      15,27,
      14,28,
      26,16,
      6,8,
      5,9,
      25,17,
      13,1,
      18,24,
      4,10,
      19,23,
      12,2,
      3,11,
      20,22
  ),ncol=2,byrow=TRUE)

xver  <- c(7,21)

ouk11n <-
  matrix(c(
      1,9,
      2,24,
      12,3,
      4,20,
      6,14,
      26,7,
      8,17,
      23,11,
      19,13,
      16,27,
      18,25
  ),byrow=TRUE,ncol=2)



symk11n <- symmetry_object(a, Mver=Mver, xver=xver)
a  <- symmetrize(as.minobj(a),symk11n)


jj <- knotoptim(filename,
                symobj = symk11n,
                ou   = ouk11n,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_4.svg"
a <- reader(filename)


Mver <- matrix(c(
    12,24,
    01,13,
    14,02,
    11,23,
    03,15,
    16,04,
    17,05,
    10,22,
    18,06,
    19,07,
    09,21,
    08,20
),ncol=2,byrow=TRUE)


sym94 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        mcdonalds=TRUE
    )


a <- symmetrize(a,sym94)
ou94  <-
    matrix(c(
        13,01,
        02,14,
        15,03,
        04,16,
        23,05,
        07,22,
        20,08,
        10,19,
        17,11
    ),byrow=TRUE,ncol=2)


#as <- symmetrize(a,sym94)
#knotplot2(as,text=T,lwd=0,circ=F)
#knotplot(as,ou94)
#stop()

jj <- knotoptim(filename,
                symobj = sym94,
                ou   = ou94,
                prob=0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_12.svg"
a <- reader(filename)

Mver <- matrix(c(
    19,07,
    06,20,
    21,05,
    22,04
),ncol=2,byrow=TRUE)


sym912 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        xver = 26
        )
    
a <- symmetrize(a,sym912)

ou912  <-
  matrix(c(
      11,02,
      03,13,
      21,06,
      07,20,
      19,08,
      09,18,
      14,10,
      25,15,
      17,24
  ),byrow=TRUE,ncol=2)

jj <- knotoptim(filename,
                symobj  = sym912,
                ou      = ou912,
                prob    = 0,
                iterlim = 9000, print.level=2
#                control=list(trace=100,maxit=10000), useNLM=FALSE
                )


write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_3.svg"
a <- reader(filename)


Mver <- matrix(c(
    10,25,
    24,11,
    12,23,
    9,1,
    22,13,
    21,14,
    8,2,
    20,15,
    19,16,
    7,3,
    6,4,
    18,17
),ncol=2,byrow=TRUE)


sym93 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        xver = 5
    )



ou93  <-
    matrix(c(
        2,14,
        16,3,
        5,17,
        19,6,
        8,20,
        22,9,
        11,25,
        24,12,
        13,23
        ),byrow=TRUE,ncol=2)

#as <- symmetrize(a,sym93)
#knotplot2(as,text=T,lwd=0,circ=F)
#knotplot(as,ou93)
#stop()

jj <- knotoptim(filename,
                symobj = sym93,
                ou   = ou93,
                prob=0,
                iterlim=9000,print.level=2
                # control=list(trace=100,maxit=1000), # these arguments for optim()
                # useNLM=FALSE
                )


write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "9_47.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mver947 <- matrix(c(
    27,01,

    07,21,
    06,22,
    05,23,

    08,20,
    
    19,09,
    18,10,

    11,17,

    26,02,
    12,16,

    25,03,
    04,24,
    13,15
    
), byrow=TRUE,ncol=2)

sym947 <-
  symmetry_object(
      a,
      Mver=Mver947,
      xver=c(14,28),
  )


a <- symmetrize(a,sym947)
##knotplot2(a)
#knotplot2(a,lwd=1,text=TRUE,rainbow=TRUE,circ=FALSE)


ou947 <- matrix(c(  # nonalternating  
    2,21,
    17,3,
    4,25,
    13,5,
    8,27,
    9,20,
    18,11,
    26,12,
    24,16
), byrow=TRUE,ncol=2)


##knotplot(a,ou947)

jj <- knotoptim(filename,
                symobj=sym947,
                ou   = ou947,
                prob=0,
                iterlim=1000, print.level=2
#               control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_2.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)



Mver <- matrix(c(
    23,1,
    13,11,
    14,10,
    22,2,
    3,21,
    4,20,
    5,19,
    15,9,
    6,18,
    16,8,
    17,7
),ncol=2,byrow=TRUE)

sym82 <- symmetry_object(a,Mver=Mver,xver=c(12,24))
a <- symmetrize(a,sym82)

#knotplot2(a,text=TRUE,lwd=1,circ=FALSE,rainbow=TRUE)



ou82 <- matrix(c(
    12,2,
    21,10,
    9,19,
    18,7,
    6,16,
    15,4,
    3,22,
    23,13
),ncol=2,byrow=TRUE)

#knotplot(a,ou82)

jj <-
  knotoptim(filename,
            symobj = sym82,
            ou   = ou82,
            prob = 0,
            iterlim=1000, print.level=2, hessian=FALSE
#                control=list(trace=100,maxit=1000), # these arguments for optim()
#                useNLM=FALSE
)

write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_19_alternative.svg"
a <- reader(filename)
Mver <- matrix(c(
    08,14,
    09,13,
    15,07,
    03,19,
    02,20,
    10,12,
    06,16,
    05,17,
    04,18
    ),ncol=2,byrow=TRUE)


## NB Not alternating!
ou819a <- matrix(c(  
    1,17,
    2,6,
    10,3,
    5,11,
    7,16,
    15,8,
    18,12,
    13,20
                   ),ncol=2,byrow=TRUE)

sym819a <- symmetry_object(a,Mver=Mver,xver=c(1,11))

jj <-
  knotoptim(filename,
            symobj = sym819a,
            ou   = ou819a,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR) 
filename <- "trefoil_of_trefoils.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mrot <- matrix(c(
    04,24,14,
    30,20,10,
    03,23,13,
    01,21,11,
    29,19,09,
    05,25,15,
    02,22,12,
    28,18,08,
    06,26,16,
    17,07,27
),ncol=3,byrow=TRUE)

Mver <- matrix(c(
    04,30,
    03,01,
    29,05,
    28,06
),ncol=2,byrow=TRUE)

symtt <- symmetry_object(a, xver=c(2,17), Mrot=Mrot,Mver=Mver)
a <- symmetrize(a,symtt)

#knotplot2(a,text=T,width=F,lwd=1,rain=T)
#stop()

outt <- matrix(c(
    02,06,
    29,03,
    05,30,
    07,18,
    27,08,
    09,13,
    15,10,
    12,16,
    17,28,
    19,23,
    25,20,
    22,26
),ncol=2,byrow=TRUE)


knotplot(a,outt)


# We will try and request that node 4 is on the vertical centreline.

jj <- knotoptim(filename,
                symobj = symtt,
                ou   = outt,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_5_90deg_crossing.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mver <- matrix(c(
    21,01,
    12,10,
    13,09,
    20,02,
    04,18,
    19,03,
    05,17,
    14,08,
    06,16,
    07,15
),ncol=2,byrow=TRUE)

sym85 <- symmetry_object(a,Mver=Mver,xver=c(11,22))
a <- symmetrize(a,sym85)
#knotplot2(a,node=TRUE)
#knotplot2(a,lwd=1,text=T,circ=F,rainbow=T)

ou85 <- matrix(c(
    11,02,
    03,18,
    19,04,
    05,20,
    14,06,
    08,15,
    17,09,
    21,12
),ncol=2,byrow=TRUE)
#knotplot(a,ou85)

w <- c(pot = 1,
      ang = 100,
      ben = 1,
      len = 1,
      mid = 1,
      clo = 1,
      swi = 1,
      con = 1,
      ncn = 1
      )

jj <-
  knotoptim(filename,weights=w,
            symobj = sym85,
            ou   = ou85,
                prob=0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "6_1.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mver <-   matrix(c(
     6,4,
     14,16,
     7,3,
     13,17,
     12,18,
     8,2,
     9,1,
     19,11,
     20,10
),ncol=2,byrow=TRUE)

sym61 <- symmetry_object(
   x    = a,
   Mver = Mver,
   xver = c(5,15)
   )

a <- symmetrize(a,sym61)
#knotplot2(a,text=TRUE,lwd=0,circ=FALSE)


ou61 <- matrix(c(
     16,4,
     3,18,
     10,1,
     19,12,
     7,15,
     13,8
),byrow=TRUE,ncol=2)

#knotplot(a,ou61)

jj <- knotoptim(filename,
                symobj = sym61,
                ou     = ou61,
                prob   = 0,
                 iterlim=1000,print.level=2         # these arguments for nlm()
#                control=list(trace=100,maxit=1000), # these arguments for optim()
#                useNLM=FALSE
                )
write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))
		

library(knotR)

filename <- "9_45.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)
#knotplot2(a,lwd=1,rainbow=TRUE,circ=FALSE,text=TRUE)


ou945 <- matrix(c(  # nonalternating
    9,2,
    3,11,
    12,5,
    21,6,
    8,19,
    14,22,
    18,15,
    16,25,
    24,17
), byrow=TRUE,ncol=2)


sym945 <- symmetry_object(a,xver=25)
a <- symmetrize(a,sym945)

##knotplot2(a)
##knotplot2(a,lwd=1,text=TRUE,circ=FALSE,rain=TRUE)
#knotplot(a,ou945)
#stop()
jj <- knotoptim(filename,
                symobj=sym945,
                ou   = ou945,
                prob=0,
                iterlim=10000, print.level=2
#                control=list(trace=100,maxit=1000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_5.svg"
a <- reader(filename)

Mver <- matrix(c(
    NA,NA
),ncol=2,byrow=TRUE)


sym95 <-
    symmetry_object(
        x    = a,
        xver = 4
    )


a <- symmetrize(a,sym95)

ou95  <-
    matrix(c(
        30,10,
        17,01,
        02,15,
        13,03,
        05,26,
        24,06,
        07,22,
        20,08,
        09,18
    ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                symobj = sym95,
                ou   = ou95,
                prob=0,
                iterlim=1000,print.level=2
#                control=list(trace=100,maxit=30000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

rm(list=ls())
library(knotR) 
filename <- "hexknot.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)


## This knot is a very challenging knot to get right.  We need to
## impose sixfold rotational symmetry, and also reflectional symmetry.

## To do this we choose nodes 1,24,8,9,15,16 as the independent ones.
## The idea is to choose nodes in the segment from 11 oclock to
## midday; but note the odd choice of 24.  We choose 24 because node 4
## has a peculiar requirement, namely that it is (a) on the line 11
## o'clock line, and (b) the handle has to be at the 2 o'clock
## direction.  And there is no functionality to do this.  So we choose
## node 24 as the independent one.

jj  <-
  matrix(c(
      01,11,21,31,41,51,
      24,34,44,54,04,14,
      08,18,28,38,48,58,
      09,19,29,39,49,59,
      15,25,35,45,55,05,
      16,26,36,46,56,06,


      02,12,22,32,42,      52,

      03,13,23,33,43,      53,
      10,20,30,40,50,60,
      17,27,37,47,57,07
  ),ncol=6,byrow=TRUE)


Mver <- matrix(c( # everything except c(9,39), which are on the vertical axis, xver
    1,17,
#    4,14,
    8,10,
    15,3,
    16,2
                                        
#
#    5,13,
#    6,12,
#    7,11,
#
#   60,18,
#    59,19,
#    58,20,
#    57,21,
#    56,22,
#    55,23,
#    54,24,
#    25,53,
#    26,52
#    51,27,
#    50,28,
#    49,29,
#    48,30,
#    47,31,
#    32,46,
#    33,45,
#    44,34,
#    43,35,
#    42,36,
#    41,37,
#    40,38
    ),ncol=2,byrow=TRUE)


#Mhor <-matrix(c( # everything except c(24,54), which are on the horizontal axis, xhor
#    8,40
#    1,47,
#    60,48,
#    7,41,
#    59,49,
#    58,50,
#    51,57,
#    6,42,
#    52,56,
#    5,43,
#    53,55,
#    4,44,
#    15,33,
#    16,32,
#    10,38,
#    17,31,
#    2,46,
#    3,45,
#    14,34,
#    25,23,
#    26,22,
#    12,36,
#    13,35,
#    11,37,
#    18,30,
#    19,29,
#    20,28,
#    27,21
    
    
 #   ),ncol=2,byrow=TRUE)


symhex <- symmetry_object(a,xver=c(9),xhor=c(24),Mver=Mver,Mrot=jj,celtic=TRUE)
a <- symmetrize(a,symhex)
#knotplot2(a,node=T,seg=T,lwd=10,circ=90)
#abline(h=0,v=0)
#stop()

#knotplot2(a,lwd=1,circ=F,text=T,rainbow=T)
#stop()
ouhex <- matrix(c(
    2,17,
    15,4,
    5,54,
    52,7,
    8,1,
    18,11,
    12,27,
    25,14,
    28,21,
    22,37,
    35,24,
    38,31,
    32,47,
    45,34,
    48,41,
    42,57,
    55,44,
    58,51



),ncol=2,byrow=TRUE)

#knotplot(a,ouhex,gap=3)
#stop()


# We will try and request that node 4 is on the vertical centreline.

jj <- knotoptim(filename,
                symobj = symhex,
                ou   = ouhex,
                prob=0,
                iterlim=200, print.level=2
#                control=list(trace=100,maxit=10000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_41.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)


Mver <- matrix(c(
    23,1,
    9,15,
    8,16,
    22,2,
    10,14,
    17,7,
    11,13,
    6,18,
    21,3,
    5,19,
    20,4
),ncol=2,byrow=TRUE)


sym941 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        xver = c(12,24)
    )
a <- symmetrize(a,sym941)
#knotplot2(a,text=TRUE,lwd=1,circ=FALSE)


ou941  <-
    matrix(c(
        2,16,
        14,3,
        5,20,
        12,6,
        7,18,
        17,8,
        9,23,
        22,11,
        19,13
        ),byrow=TRUE,ncol=2)

as <- symmetrize(a,sym941)
#knotplot2(as,text=T,lwd=0,circ=F)
#knotplot(as,ou941)


jj <- knotoptim(filename,
                symobj = sym941,
                ou   = ou941,
                prob=0,
                iterlim=9000,print.level=2
#               control=list(trace=100,maxit=1000), useNLM=FALSE
                )


write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "4_1a.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mver <- matrix(c(
    23,01,
    08,16,
    07,17,
    22,02,
    15,09,
    06,18,
    05,19,
    14,10,
    21,03,
    04,20,
    13,11
),ncol=2,byrow=TRUE)

Mhor <- matrix(c(
    07,05,
    22,14,
    23,13,
    08,04,
    15,21,
    16,20,
    09,03,
    02,10,
    01,11,
    17,19
),ncol=2,byrow=TRUE)

sym41 <- symmetry_object(a,Mver=Mver,Mhor=Mhor,xver=c(12,24),xhor=c(6,18),reefknot=T)
a <- symmetrize(a,sym41)
#knotplot2(a,node=T,seg=T,lwd=1)
#knotplot2(a,text=TRUE,lwd=1,rainbow=TRUE,circ=FALSE)

ou41 <-
    matrix(c(
        02,17,
        03,10,
        04,21,
        14,05,
        23,08,
        16,09,
        11,20,
        15,22
),ncol=2,byrow=TRUE)

#knotplot(a,ou41)


jj <- knotoptim(filename,
                symobj = sym41,
                ou   = ou41,
                prob=0,
#                iterlim=1000, print.level=2
                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "9_42.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)
#knotplot2(a,lwd=1,rainbow=TRUE,circ=FALSE,text=TRUE)

ou942 <- matrix(c(  # nonalternating
    2,12,
    10,3,
    21,4,
    6,23,
    7,15,
    14,9,
    17,24,
    26,18,
    20,27
), byrow=TRUE,ncol=2)

#knotplot(a,ou942,gap=10)


sym942 <- symmetry_object(a,xver=28)
a <- symmetrize(a,sym942)
##knotplot2(a)
##knotplot2(a,lwd=1,text=TRUE,circ=FALSE,rain=TRUE)
##knotplot(a,ou942)


jj <- knotoptim(filename,
                symobj=sym942,
                ou   = ou942,
                prob=0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_19.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mver <- matrix(c(
    8,14,
    9,13,
    15,7,
    2,20,
    16,6,
    3,19,
    4,18,
    10,12,
    5,17
),ncol=2,byrow=TRUE)


sym819 <- symmetry_object(a,Mver=Mver,xver=c(1,11))
a <- symmetrize(a,sym819)
#knotplot2(a,node=T)
#knotplot2(a,circ=FALSE,text=TRUE,rainbow=TRUE,lwd=1)

ou819 <- matrix(c(  # NB Not alternating!
    15,8,
    13,20,
    18,12,
    5,11,
    10,3,
    1,7,
    6,17,
    2,16
),ncol=2,byrow=TRUE)

#knotplot(a,ou819)

jj <-
  knotoptim(filename,
            symobj = sym819,
            ou   = ou819,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_8.svg"
a <- reader(filename)

sym88 <- symmetry_object(a,Mver=NULL,xver=12)
a <- symmetrize(a,sym88)
#knotplot2(a,node=T)
#knotplot2(a,lwd=1,text=T,circ=F)
ou88 <- matrix(c(
    08,02,
    03,06,
    13,05,
    06,14,
    20,09,
    10,16,
    18,11,
    15,19
),ncol=2,byrow=TRUE)
#knotplot(a,ou88)

jj <-
  knotoptim(filename,
            symobj = sym88,
            ou   = ou88,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_4_alternative.svg"
a <- reader(filename)

Mver <- matrix(c(
    15,12,
    16,11,
    26,01,
    25,02,
    24,03,
    14,13,
    17,10,
    23,04,
    09,18,
    08,19,
    22,05,
    07,20,
    06,21
),ncol=2,byrow=TRUE)

sym84 <- symmetry_object(a,Mver=Mver,xver=27)
a <-symmetrize(a,sym84)
#knotplot2(symmetrize(a,sym84),node=FALSE,text=T,lwd=0.1,circ=F)

ou84 <- matrix(c(
    13,02,
    03,11,
    19,05,
    06,22,
    23,09,
    17,25,
    26,15,
    10,18
),ncol=2,byrow=TRUE)

#knotplot(a,ou84)

jj <-
  knotoptim(filename,
            symobj = sym84,
            ou     = ou84,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_28.svg"
a <- reader(filename)
#knotplot2(a,node=T)
#stop()

Mver928 <- matrix(c(
    05,16,
    06,17,
    12,01,
    13,02,
    11,22,
    15,04,
    07,18,
    14,03,
    21,10,
    08,19,
    09,20
    ),ncol=2,byrow=TRUE)


sym928 <-
    symmetry_object(
        x    = a,
        xver = NULL,
        Mver = Mver928,
        mcdonalds=TRUE
    )


a <- symmetrize(a,sym928)
#knotplot2(a,seg=F,text=T,node=T,circ=0,lwd=1,rainbow=TRUE)
#stop()


ou928  <-
    matrix(c(
        18,01,
        03,19,
        22,04,
        05,16,
        12,07,
        08,14,
        21,10,
        11,22,
        15,11
    ),byrow=TRUE,ncol=2)

#knotplot(a,ou928)
#stop()

jj <- knotoptim(filename,
                symobj  = sym928,
                ou      = ou928,
                prob    = 0,
                iterlim = 9000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "7_2.svg"
a <- reader(filename)
#knotplot2(a,node=T)

Mver <- matrix(c(
    13,02,
    12,01,
    11,22,
    03,14,
    04,15,
    05,16,
    10,21,
    06,17,
    09,20,
    18,07,
    08,19
    ),ncol=2,byrow=TRUE)

sym72 <- symmetry_object(x=a, Mver = Mver, mcdonalds=TRUE)
a <- symmetrize(a,sym72)
#knotplot2(a,node=T)
#knotplot2(a,node=F,lwd=1,text=T)


ou72 <- 
    matrix(c(
        15,22,
        21,17,
        18,07,
        08,19,
        03,14,
        11,04,
        06,10
        ),byrow=TRUE,ncol=2)

#knotplot(a,ou72)



jj <- knotoptim(filename,
                symobj = sym72,
                ou   = ou72,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "9_23.svg"
a <- reader(filename)


Mver923 <- 
    matrix(
        c(
            26,01,
            09,18,
            10,17,
            11,16,
            25,02,
            08,19,
            07,20,
            24,03,
            06,21,
            12,15,
            04,23,
            05,22,
            13,14
        ), byrow=TRUE,ncol=2)

sym923 <-
    symmetry_object(a,Mver=Mver923,celtic=FALSE,xver=27)
a <- symmetrize(a,sym923)


ou923 <- matrix(  # alternating
    c(
        02,18,
        20,03,
        04,24,
        13,05,
        07,12,
        25,08,
        10,26,
        23,15,
        16,21
    ) , byrow=TRUE,ncol=2)

jj <- knotoptim(filename,
                symobj=sym923,
                ou   = ou923,
                prob=0,
                iterlim=1000,print.level=2
#                control=list(trace=100,maxit=1000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_10.svg"
a <- reader(filename)
#knotplot2(a,node=T)

sym810 <- symmetry_object(a,Mver=NULL,xver=c(9,16,23))
a <- symmetrize(a,sym810)
#knotplot2(a,lwd=1,text=T,rain=T)

           


ou810 <- matrix(c(
    22,08,
    06,21,
    19,05,
    14,19,
    18,10,
    09,15,
    03,13,
    11,02
),ncol=2,byrow=TRUE)

#knotplot(a,ou810)


jj <-
  knotoptim(filename,
            symobj = sym810,
            ou   = ou810,
            prob = 0,
            iterlim = 1000,print.level=2,hessian=FALSE
#                control=list(trace=100,maxit=10000), useNLM=FALSE
                )


write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

## This shows how to impose reflectional symmetry on
## k9_1, the nine-sided starry knot.
library(knotR)
filename <- "9_1.svg"
a <- reader(filename)
            
Mver <- matrix(c(
    53,01,
    26,28
),ncol=2,byrow=TRUE)


Mrot <-
`[<-`(sweep(matrix(seq(from=1,by=30,len=54),byrow=TRUE,ncol=9),1,c(52:54,25:27),"+")%%54,2,1,54)

sym91 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        xver = c(27,54),
        Mrot = Mrot,
        )

as <- symmetrize(a,sym91)


ou91  <-
    matrix(c(
        02,29,
        32,05,
        08,35,
        38,11,
        14,41,
        44,17,
        20,47,
        50,23,
        26,53
        ),byrow=TRUE,ncol=2)

jj <- knotoptim(filename,
                symobj = sym91,
                ou   = ou91,
                prob=0,
                iterlim=1000,print.level=2
                )


write_svg(jj,filename,safe=FALSE)

## This shows how to symmetrize 4_1.svg (aka the "figure of eight knot")

## First read the inkscape file:
a <- reader("~/packages/rhankin/packages/trunk/knot/inst/4_1_not_symmetric.svg")

knotplot(a)
## Now create a symmetry object (look at the knotplot(a) to see the
## nodes that are mirror images, and the nodes that are on the
## centreline)

jjM <-
  matrix(c(
      1,3,
      7,5,
      4,8
  ),byrow=TRUE,ncol=2)

jjv <- c(2,6)


sym_4_1 <- symmetry_object(a, M=jjM, v=jjv)

## Function symmetrize_LR() creates a symmetrized knot:
k4_1_symmetrized <- symmetrize_LR(as.minobj(a), sym_4_1)


knotplot(k4_1_symmetrized)  #OK, OK, it looks terrible

mii <- make_minsymvec_from_minobj(k4_1_symmetrized,sym_4_1)

# now optimize; first define an objective function:

`objective_function` <- function(m){
    badness(make_minobj_from_minsymvec(m,sym_4_1))
}

o <- nlm(objective_function,mii,iterlim=7,print.level=2)


## OK, the nlm() optimization above works, and returns a nicely optimized knot, after about 200 iterations.

## following line overwrites o$estimate with "one I made earlier":

o$estimate <-
c(-282.644533578784, 185.947356969593, 229.547253138081, 11.5964447756388, 
104.750560354452, 467.63782, 68.8193140434279, -835.952760393696, 
327.63782, -516.091428691126, 97.4178402741775, 415.712781279902, 
84.1214810420745, 399.808094476753, -43.1012874450844, -344.154370716368, 
147.64299276457, -336.152933363871)




## create  the symmetric optimized knot:
k4_1_symmetric_optimized <- make_minobj_from_minsymvec(o$estimate,sym_4_1)

## look at it:
knotplot(k4_1_symmetric_optimized)
# still sucks (it looks a little better after 30 iterations, honest)

## Further optimization:
oo <- nlm(objective_function,o$estimate,iterlim=3,print.level=2

          )

## Try knotplot2():
## Need an overunderobject:

overunder_4_1 <-
    matrix(
        c(
            1,4,
            7,2,
            3,6,
            5,8),
        ncol=2,byrow=TRUE
        )


knotplot2(k4_1_symmetric_optimized,overunder_4_1)
## Now write a new inkscape file using write_svg():
write_svg(k4_1_symmetric_optimized,
          oldfile = "~/packages/rhankin/packages/trunk/knot/inst/4_1_not_symmetric.svg",
          newfile = "~/packages/rhankin/packages/trunk/knot/inst/4_1_yes_symmetric.svg"
          )

library(knotR)
filename <- "9_9.svg"
a <- reader(filename)


Mver <- matrix(c(
    14,23,
    13,01,
    22,15,
    12,02,
    03,11,
    21,16,
    10,04,
    09,05,
    20,17,
    08,06,
    19,18
),ncol=2,byrow=TRUE)

sym99 <-
    symmetry_object(
        x    = a,
        xver = 7,
        Mver = Mver
    )

a <- symmetrize(a,sym99)

ou99  <-
    matrix(c(
        16,02,
        03,12,
        11,04,
        05,17,
        18,07,
        08,20,
        21,10,
        13,22,
        23,15
    ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                symobj  = sym99,
                ou      = ou99,
                prob    = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_11.svg"
a <- reader(filename)


sym911 <-
    symmetry_object(
        x    = a,
        Mver = NULL,
        xver = 14
        )
    
a <- symmetrize(a,sym911)


ou911  <- matrix(c(
    01, 21,
    19, 02,
    04, 12,
    14, 05,
    07, 15,
    17, 08,
    10, 23,
    22, 11,
    12, 18
),byrow=TRUE,ncol=2)



jj <- knotoptim(filename,
                symobj  = sym911,
                ou      = ou911,
                prob    = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=10000), useNLM=FALSE# these arguments for optim()
                )



write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_24.svg"

a <- reader(filename)
#knotplot2(a,node=TRUE)

sym924 <-
    symmetry_object(
        x    = a,
        xver = 30,
        mcdonalds=FALSE
    )

a <- symmetrize(a,sym924)
#knotplot2(a,lwd=1,text=TRUE,rainbow=TRUE,circ=FALSE)

ou924  <-
    matrix(c(
    05,29,
    28,11,
    09,27,
    26,19,
    17,25,
    24,15,
    02,21,
    20,04,
    12,08
),byrow=TRUE,ncol=2)


#knotplot(a,ou924)

jj <- knotoptim(filename,
                symobj  = sym924,
                ou      = ou924,
                prob    = 0,
                iterlim= 1000, print.level=2
#               control=list(trace=100,maxit=1000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR) 
filename <- "sum_3_1_and_4_1.svg"
a <- reader(filename)

sym34 <- symmetry_object(a, xver=18)
a <- symmetrize(a,sym34)

ou34 <- matrix(c(
    01,07,
    06,02,
    10,03,
    05,09,
    15,11,
    12,17,
    18,14
),ncol=2,byrow=TRUE)

knotplot(a,ou34)


jj <- knotoptim(filename,
                symobj = sym34,
                ou   = ou34,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "k12n_0411.svg"
a <- reader(filename)

Mver <-
  matrix(c(
      27,01,
      18,20,
      26,02,
      07,21,
      03,25,
      24,04,
      09,13,
      05,23,
      06,22,
      10,12
  ),ncol=2,byrow=TRUE)


sym11 <- symmetry_object(a, Mver=Mver,xver=c(11,15,19,28))

ou11 <- matrix(c(
    01,15,
    20,02,
    03,26,
    25,04,
    05,24,
    06,10,
    17,08,
    09,18,
    23,13,
    14,21,
    16,28,
    27,19
),byrow=TRUE,ncol=2)


a <- symmetrize(a,sym11)

jj <- knotoptim(filename,
                symobj = sym11,
                ou = ou11,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_4.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE,seg=T)
#stop()
sym84 <- symmetry_object(a,xver=6)
a <- symmetrize(a,sym84)
#knotplot2(a,text=T,lwd=0.1,circ=F,rainbow=T)
#stop()

ou84 <- matrix(c(
2,15,
17,4,
6,19,
29,7,
9,27,
25,11,
13,23,
30,20
),ncol=2,byrow=TRUE)

jj <-
  knotoptim(filename,
            symobj = sym84,
            ou   = ou84,
            prob = 0,
            iterlim=1000,print.level=2,hessian=FALSE
#            control=list(trace=100,maxit=10000),useNLM=FALSE
            )

write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_20.svg"
a <- reader(filename)
#knotplot2(a,node=T)


sym820 <- symmetry_object(a,Mver=NULL,xver=20)
a <- symmetrize(a,sym820)
#knotplot2(a,lwd=1,text=TRUE,circ=FALSE,rainbow=TRUE)

ou820 <- matrix(c(
    25,16,
    17,08,
    03,18,
    19,11,
    12,22,
    23,04,
    07,24,
    09,02
),ncol=2,byrow=TRUE)

#knotplot(a,ou820)



jj <-
  knotoptim(filename,
            symobj = sym820,
            ou   = ou820,
            prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
            )

write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "k11a361.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mver <-
  matrix(c(
      14,28,
      15,1,
      27,13,
      26,12,
      25,11,
      16,2,
      5,19,
      17,3,
      24,10,
      6,20,
      7,21,
      9,23,
      22,8
  ),ncol=2,byrow=TRUE)

symk11 <- symmetry_object(a,Mver,mcdonalds=TRUE)
a <- symmetrize(a,symk11)
#knotplot2(a)
#knotplot2(a,lwd=1,text=TRUE,circ=FALSE)

ouk11 <-
  matrix(c(
      14,28,
      2,13,
      11,20,
      24,10,
      9,23,
      22,8,
      6,25,
      17,5,
      4,18,
      19,3,
      27,16
  ),byrow=TRUE,ncol=2)
#knotplot(a,ouk11)


a  <- symmetrize(as.minobj(a),symk11)

jj <- knotoptim(filename,
                symobj = symk11,
                ou   = ouk11,
                prob=0,
                iterlim=1000, print.level=2
                )


write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

# produces knottable.pdf.



# Compare allknotplotter.R, which plots  every knot in the package.


filename <- "knottable.pdf"

library(knotR)
library(magrittr)

affine <- function(M,offset,scale){
    cm <- colMeans(M)
    M %<>% sweep(2,cm-offset) %>% "*"(scale) %>% sweep(2,-cm)
    return(M)
}

scaled_knotplot <- function(knot,offset,scale=1,...){
    knotplot(
        x  = affine(as.inkscape(knot),offset=offset,scale=scale),
        ou = knot$overunder,add=TRUE, ...)
}

x0 <- 1000
y0 <- 0


xd <- +2200   # horizontal distance between knots
yd <- -2200   # vertical distance
list_o_knots <- list(
    unknot, k3_1,   k4_1,   k5_1,  k5_2,
    k6_1  , k6_2,   k6_3,   k7_1,  k7_2,
    k7_3  , k7_4,   k7_5,   k7_6,  k7_7
)


pdf(file="knottable.pdf")
plot(NA,xlim=c(0,13000),ylim=c(-8000,0),asp=1,pty='m',type='n')

for(i in 1:5){
    for(j in 1:3){
        n <- i +(j-1)*5  # knot to plot
        scaled_knotplot(list_o_knots[[n]],
                        offset=c(x0+xd*(i-1),y0+yd*(j-1)),lwd=2
                        )
    }
}  # plot commands end

dev.off()

library(knotR)
filename <- "9_6.svg"
a <- reader(filename)
#knotplot2(a)
#knotplot2(a,node=T,circ=F)


Mver <- matrix(c(
    12,14,
    25,1,
    11,15,
    16,10,
    24,2,
    9,17,
    8,18,
    23,3,
    7,19,
    6,20,
    22,4,
    21,5
),ncol=2,byrow=TRUE)


sym96 <-
    symmetry_object(
        x    = a,
        xver = c(13,26),
        Mver = Mver
    )


a <- symmetrize(a,sym96)
#knotplot2(a,circ=T,s)
#knotplot2(a,text=T,lwd=1,rainbow=T,circ=F)

ou96  <-
    matrix(c(
        01,15,
        18,03,
        04,20,
        21,06,
        07,23,
        24,09,
        10,17,
        16,11,
        12,26
    ),byrow=TRUE,ncol=2)
#knotplot(a,ou96)
#stop()
jj <- knotoptim(filename,
                symobj  = sym96,
                ou      = ou96,
                prob    = 0,
                iterlim = 9000, print.level=2
#                control=list(trace=100,maxit=1000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "9_33.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)
#knotplot2(a,text=TRUE,lwd=1,rain=TRUE,circ=FALSE,)


ou933 <- matrix(c(  # alternating  
    06,23,
    22,15,
    10,21,
    20,28,
    30,19,
    16,08,
    14,04,
    03,11,
    27,02
), byrow=TRUE,ncol=2)


#knotplot(a,ou933)

sym933 <- symmetry_object(a,Mver=NULL,xver=31)
#knotplot2(symmetrize(a,sym933))

jj <- knotoptim(filename,
                symobj=sym933,
                ou   = ou933,
                prob=0,
                iterlim=1000,print.level=2
#                control=list(trace=100,maxit=10000), # these arguments for optim()
#                useNLM=FALSE

                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

## This R script is a bit like trefoil_circles.R.  It plots (a
## projection of) k_3a assuming that the strand is an elastica.  The
## constraints are: (1), strands cross at right angles; the strands
## exert a couple but no force on one another; (2), mirror symmetry
## about the vertical.  Constraint #1 implies that the strands are
## arcs of a circle, or straight lines.

## NB this file produces k3_1a_circles.pdf, which is not production
## quality!  It needs to be tidied up in inkscape before anyone sees
## it.


`circ` <- function(x,y,r,start=0,finish=2*pi, ...){
  theta <- seq(from=start,to=finish,len=100)
  points(x+r*cos(theta),y+r*sin(theta),type="l",lwd=11, ...)
}

pdf(file="k3_1a_circles.pdf")
par(pty='s')
plot(NA,xlim=c(-5,5),ylim=c(-5,5),asp=1,axes=FALSE,xlab="",ylab="")

circ(+1,+1,sqrt(2),3*pi/4,5*pi/4)
circ(-1,+1,sqrt(2),-pi/4,pi/4)
circ(+1,-1,sqrt(2),3*pi/4,5*pi/4)
circ(-1,-1,sqrt(2),-pi/4,pi/4)

circ(-2,0,2*sqrt(2),7*pi/4,pi/4)
circ(+2,0,2*sqrt(2),5*pi/4,11*pi/4)

dev.off()

library(knotR)

filename <- "9_38.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)
#knotplot2(a,lwd=1,rainbow=TRUE,circ=FALSE,text=TRUE)

ou938 <- matrix(c(  # alternating  
    18,02,
    03,20,
    13,05,
    06,12,
    21,07,
    08,17,
    16,10,
    11,22,
    23,15
), byrow=TRUE,ncol=2)

#knotplot(a,ou938,gap=4)


sym938 <- symmetry_object(a,xver=c(16,24))
a <- symmetrize(a,sym938)
##knotplot2(a)
##knotplot2(a,lwd=1,text=TRUE,circ=FALSE,rain=TRUE)
##knotplot(a,ou936)


jj <- knotoptim(filename,
                symobj=sym938,
                ou   = ou938,
                prob=0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=1000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_10.svg"
a <- reader(filename)

Mver <- matrix(c(
    12,24,
    13,01,
    23,11,
    22,10,
    14,02,
    03,15,
    16,04,
    21,09,
    05,17,
    06,18,
    20,08,
    07,19
),ncol=2,byrow=TRUE)



sym910 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        xver = NULL,
        mcdonalds=TRUE
    )
a <- symmetrize(a,sym910)

ou910  <-
  matrix(c(
      12,24,
      02,11,
      09,18,
      20,08,
      06,21,
      17,05,
      04,16,
      15,03,
      23,14
        ),byrow=TRUE,ncol=2)

jj <- knotoptim(filename,
                symobj  = sym910,
                ou      = ou910,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "5_1.svg"
jj <- knotoptim(filename,
                Mver = matrix(c(11,13), byrow=TRUE,ncol=2),
                xver = c(2,12),
                Mrot = rbind(c(12,4,16,8,20),c(13,5,17,9,1),c(11,3,15,7,19),c(2,14,6,18,10)),
                ou   = matrix(c(2,11,14,3,6,15,18,7,10,19),ncol=2,byrow=TRUE),
                prob=0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

## This shows how to impose reflectional symmetry on
## k7_1, the seven-sided starry knot.

filename <- "7_1.svg"
a <- reader(filename)

Mver <- matrix(c(
    09,10,
    19,21,
    18,01,
    08,11,
    07,12,
    06,13,
    17,02,
    05,14,
    16,03,
    15,04
    ),ncol=2,byrow=TRUE)

Mrot <-
    rbind(
        c(09,21,12,03,15,06,18),
        c(10,01,13,04,16,07,19),
        c(20,11,02,14,05,17,08)
        )

sym71 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        xver = 20,
        Mrot = Mrot,
        )


ou71  <-
    matrix(c(
        12,2,
        3,14,
        5,15,
        17,6,
        8,18,
        20,9,
        11,21
        ),byrow=TRUE,ncol=2)



jj <- knotoptim(filename,
                symobj = sym71,
                ou   = ou71,
                prob=0.01,
                iterlim=100,print.level=2
                )


write_svg(jj,filename)
stop() 






## Function symmetrize_LR() creates a symmetrized knot:
k71 <- symmetrize(as.minobj(a), sym71)

knotplot(k71,T,T,T,T,T,circ=500)  #OK, it looks terrible
grid()

mii <- make_minsymvec_from_minobj(k71,sym71)
pii <- make_minobj_from_minsymvec(mii,sym71)


ou71  <-
    matrix(c(
        12,2,
        3,14,
        5,15,
        17,6,
        8,18,
        20,9,
        11,21
        ),byrow=TRUE,ncol=2)

knotplot2(k71, ou71,gap=10)

# now optimize; first define an objective function:

`objective_function` <- function(m){
    badness(make_minobj_from_minsymvec(m, sym71),prob=0.1)
}

o <- nlm(objective_function,mii,iterlim=100,print.level=2)
knotplot(make_minobj_from_minsymvec(o$estimate,sym71),T,T,T,T,circ=1900)
stop("intentional")


# create the knot object:
trefoil_symmetric_opt <- make_minobj_from_minsymvec(o$estimate,sym_fig8)


##  A couple of plots:
knotplot(trefoil_symmetric_opt,T,T,T,T,circ=1900)
knotplot2(trefoil_symmetric_opt,ou_3_1)




## Now write a new inkscape file using write_svg():
write_svg(trefoil_symmetric_opt,
          oldfile = "~/packages/rhankin/packages/trunk/knot/inst/3_1_not_symmetric.svg",
          newfile = "~/packages/rhankin/packages/trunk/knot/inst/3_1_yes_symmetric.svg"
          )

library(knotR)
filename <- "10_47.svg"
a <- reader(filename)
#knotplot2(a,circ=200)
#knotplot2(a,circ=200,node=T)


Mver <-
  matrix(c(
      28,20,
      01,19,
      18,02,
      17,03,
      16,04,
      15,05
  ),ncol=2,byrow=TRUE)

xver <- 24

sym1047 <- symmetry_object(a, Mver=Mver, xver=xver)
#knotplot2(symmetrize(a,sym1047),seg=T)
#knotplot2(symmetrize(a,sym1047),seg=F,lwd=1,text=T,rainbow=T,circ=0)
#stop()

ou1047 <- matrix(c(
    02,19,
    21,04,
    06,22,
    10,07,
    08,14,
    14,09,
    24,11,
    13,25,
    27,15,
    17,28
),byrow=TRUE,ncol=2)

#knotplot(a,ou1047)
#stop()



jj <- knotoptim(filename,
                symobj = sym1047,
                ou = ou1047,
		prob = 0,
                iterlim=2000, print.level=2
#                control=list(trace=100,maxit=1000), # these arguments for optim()
#                useNLM=FALSE
                )


write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "longthin.svg"
a <- reader(filename)

MverLT <- 
    matrix(
        c(
            11,09,
            22,24,
            21,25,
            20,26,
            01,19,
            18,02,
            03,17,
            16,04,
            05,15,
            14,06,
            07,13,
            12,08
        ), byrow=TRUE,ncol=2)

symLT <- symmetry_object(a,Mver=MverLT,celtic=FALSE,xver=c(10,23))
a <- symmetrize(a,symLT)

ouLT <- matrix(  # alternating
    c(
        01,20,
        19,02,
        03,18,
        17,04,
        05,16,
        15,06,
        07,14,
        13,08,
        09,24,
        23,12
    ) , byrow=TRUE,ncol=2)

jj <- knotoptim(filename,
                symobj=symLT,
                ou   = ouLT,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_14.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

sym814 <- symmetry_object(a,Mver=NULL,xver=23)
a <- symmetrize(a,sym814)
#knotplot2(a,text=T,lwd=1,rain=T,circ=F)


ou814 <- matrix(c(
    19,25,
    26,5,
    10,27,
    28,12,
    22,2,
    4,20,
    6,16,
    15,9
),ncol=2,byrow=TRUE)

#knotplot(a,ou814)

jj <-
  knotoptim(filename,
            symobj = sym814,
            ou   = ou814,
            prob = 0,
            iterlim=1000,print.level=2,hessian=FALSE
#                control=list(trace=100,maxit=10000), useNLM=FALSE
)


write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_5.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mver <- matrix(c(
    21,01,
    12,10,
    13,09,
    20,02,
    04,18,
    19,03,
    05,17,
    14,08,
    06,16,
    07,15
),ncol=2,byrow=TRUE)

sym85 <- symmetry_object(a,Mver=Mver,xver=c(11,22))
a <- symmetrize(a,sym85)
#knotplot2(a,node=TRUE)
#knotplot2(a,lwd=1,text=T,circ=F,rainbow=T)

ou85 <- matrix(c(
    11,02,
    03,18,
    19,04,
    05,20,
    14,06,
    08,15,
    17,09,
    21,12
),ncol=2,byrow=TRUE)
#knotplot(a,ou85)

jj <-
  knotoptim(filename,
            symobj = sym85,
            ou   = ou85,
                prob=0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "7_6.svg"
a <- reader(filename)
sym76 <- symmetry_object(a,xver=2)      # no real symmetry, but force
                                        # node 2 to be on the
                                        # centreline


ou76 <- matrix(c(
    12,01,
    02,11,
    07,03,
    04,15,
    16,06,
    14,08,
    10,13
    ),byrow=TRUE,ncol=2)

## Function symmetrize_LR() creates a symmetrized knot:
k76 <- symmetrize(as.minobj(a), sym76)



jj <- knotoptim(filename,
                symobj = sym76,
                ou   = ou76,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR) 
filename <- "ornamental20.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)


jj  <-
  matrix(c(
      15:25,
      37:47,
      04:14,
      26:36,
      48:55,1:3
      ),nrow=5,byrow=TRUE)


sym20 <- symmetry_object(a, xver=4, Mrot=t(jj))
a <- symmetrize(a,sym20)
#knotplot2(a)
#knotplot2(a,lwd=1,circ=F,text=T,rainbow=T)



ou20 <- matrix(c(
    1,50,  #1
    31,2,  #2
    3,33,  #3 
    27,4,  #4  
     5,37, #5
    12,6, #6
    9,35, #7
    36,11, #8
    42,13, #9
    14,44, #10 
    38,15, #11
    16,48, #12
    23,17, #13
    20,46, #14
    47,22, #15
    53,24, #16
    25,55,  #17
    34,28,  #18
    45,39,  # 19
    49,26  #20
    
),ncol=2,byrow=TRUE)

#knotplot(a,ou20)


# We will try and request that node 4 is on the vertical centreline.

jj <- knotoptim(filename,
                symobj = sym20,
                ou   = ou20,
                prob=0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=10000), # these arguments for optim()
#                useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "flower.svg"
a <- reader(filename)

Mrot <- matrix(c(
    29,01,08,15,22,
    28,35,07,14,21,
    20,27,34,06,13,
    02,09,16,23,30,
    31,03,10,17,24,
    26,33,05,12,19,
    25,32,04,11,18
    ),byrow=TRUE,ncol=5)

Mver <- matrix(c(
    29,28,
    20,02,
    30,27,
    31,26,
    19,03,
    25,32
),ncol=2,byrow=TRUE)

symflower <-
    symmetry_object(
        x    = a,
        Mver = Mver,
       Mrot = Mrot,
        xver = 11,
        mcdonalds=FALSE
        )

as <- symmetrize(a,symflower)

#knotplot2(as,node=T,seg=T,width=T)
knotplot2(as,node=F,lwd=1,width=F,text=T)

ouflower  <-
    matrix(c(
        05, 11,  #1
        07, 16,  #2
        17, 06,  #3
        12, 18,  #4
        14, 23,  #5
        24, 13,  #6
        19, 25,  #7
        03, 27,  #8
        28, 02,  #9
        21, 30,  #10
        31, 20,  #11
        26, 32,  #12
        33, 04,  #13
        10, 34,  #14
        35, 09   #15

        ),byrow=TRUE,ncol=2)

knotplot(as,ouflower,gap=10)

jj <- knotoptim(filename,
                symobj = symflower,
                ou   = ouflower,
                prob=0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "k12n_0242.svg"
a <- reader(filename)

Mver <-
  matrix(c(
      06,28,
      05,01,
      27,07,
      26,08,
      04,02,
      25,09,
      16,18,
      15,19,
      24,10,
      14,20,
      23,11,
      22,12,
      13,21
  ),ncol=2,byrow=TRUE)


sym242 <- symmetry_object(a, Mver=Mver, xver=c(3,17))

a <- symmetrize(a,sym242)

ou242 <- matrix(c(  # NB nonalternating!
    02,08,
    03,18,
    17,04,
    27,05,
    07,28,
    10,19,
    20,11,
    12,21,
    22,13,
    14,23,
    24,15,
    16,25
),byrow=TRUE,ncol=2)



jj <- knotoptim(filename,
                symobj = sym242,
                ou = ou242, 
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_7.svg"
a <- reader(filename)

Mver <- matrix(c(
    11,12,
    22,01,
    10,13,
    14,09,
    08,15,
    16,07,
    21,02,
    06,17,
    20,03,
    05,18,
    04,19
),ncol=2,byrow=TRUE)


sym97 <-
    symmetry_object(
        x    = a,
        xver = 23,
        Mver = Mver
    )


a <- symmetrize(a,sym97)

ou97  <-
    matrix(c(
        01,13,
        18,03,
        04,20,
        21,06,
        07,17,
        16,08,
        09,15,
        14,10,
        11,23
    ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                symobj  = sym97,
                ou      = ou97,
                prob    = 0,
                iterlim = 1000, print.level=2
#                control=list(trace=100,maxit=1000), # these arguments for optim()
#                useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_2.svg"
a <- reader(filename)


Mver <- matrix(c(
    13,26,
    25,12,
    14,01,
    10,23,
    11,24,
    09,22,
    15,02,
    16,03,
    08,21,
    17,04,
    18,05,
    07,20,
    06,19
),ncol=2,byrow=TRUE)


sym92 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        xver = NULL,
        mcdonalds=TRUE
        )


as <- symmetrize(a,sym92)


ou92  <-
    matrix(c(
        02,24,
        22,03,
        05,21,
        19,06,
        08,18,
        16,09,
        11,15,
        25,12,
        13,26
        ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                symobj = sym92,
                ou   = ou92,
                prob=0,
                iterlim=1000,print.level=2
                )


write_svg(jj,filename,safe=FALSE)

library(knotR)
filename <- "k11n157.svg"
a <- reader(filename)

knotplot2(a,text=T,lwd=1,width=0)

Mver <-
  matrix(c(
      12,22,
      21,13,
      05,07,
      11,01,
      20,14,
      15,19,
      10,02,
      04,08,
      16,18,
      03,09
  ),ncol=2,byrow=TRUE)

xver  <- c(6,17)

ouk11n <-
  matrix(c(
      01,08,
      02,19,
      10,03,
      04,17,
      05,12,
      21,06,
      07,14,
      18,09,
      16,11,
      15,20,
      13,22
  ),byrow=TRUE,ncol=2)



symk11n <- symmetry_object(a, Mver=Mver, xver=xver)
a  <- symmetrize(as.minobj(a),symk11n)

jj <- knotoptim(filename,
                symobj = symk11n,
                ou   = ouk11n,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

jj <-
  knotoptim("~/packages/rhankin/packages/trunk/knot/inst/3_1_not_symmetric.svg",
            Mver = rbind(c(6,7),c(1,3),c(5,8),c(9,4)),
            xver = 2,
            Mrot = rbind(c(6,3,9),c(7,4,1),c(2,8,5)),
            ou   = matrix(c(2,6, 8,3, 5,9),ncol=2,byrow=TRUE),
            prob=0.1, give=TRUE,
            
            iterlim=300,print.level=2,hessian=TRUE)
            


stop()
## This shows how to impose threefold rotational symmetry on  3_1.svg (aka the "trefoil knot")

## First read the inkscape file:
a <- reader(system.file("3_1_not_symmetric.svg",package="knot"))
knotplot(a)

## Now create a symmetry object (look at the knotplot(a) to see the
## nodes that are rotationally related, and also the nodes that are on
## the centreline)

jjM <- rbind(c(6,7),c(1,3),c(5,8),c(9,4))  # vertical symmetry
jjv <- 2  # node on centerline
jjMrot <- rbind(c(6,3,9),c(7,4,1),c(2,8,5))

sym_3_1 <- symmetry_object(a, Mver=jjM, xver=jjv, Mrot=jjMrot)   # order of the rotational symmetry defined by ncol(Mrot)


## Function symmetrize_LR() creates a symmetrized knot:
k3_1_symmetrized <- symmetrize(as.minobj(a), sym_3_1)


knotplot(k3_1_symmetrized,T,T,T,T,T,circ=200)  #OK, OK, it looks terrible


mii <- make_minsymvec_from_minobj(k3_1_symmetrized,sym_3_1)
pii <- make_minobj_from_minsymvec(mii,sym_3_1)

# now optimize; first define an objective function:

`objective_function` <- function(m){
    badness(make_minobj_from_minsymvec(m,sym_3_1),prob=0.1)
}

o <- nlm(objective_function,mii,iterlim=100,print.level=2,stepmax=100)

knotplot(make_minobj_from_minsymvec(o$estimate,sym_3_1),T,T,T,T,circ=1900)


ou_3_1 <- matrix(c(2,6, 8,3, 5,9),ncol=2,byrow=TRUE)


# create the knot object:
trefoil_symmetric_opt <- make_minobj_from_minsymvec(o$estimate,sym_3_1)


##  A couple of plots:
knotplot(trefoil_symmetric_opt,T,T,T,T,circ=1900)
knotplot2(trefoil_symmetric_opt,ou_3_1)

## Now write a new inkscape file using write_svg():
write_svg(trefoil_symmetric_opt,
          oldfile = "~/packages/rhankin/packages/trunk/knot/inst/3_1_not_symmetric.svg",
          newfile = "~/packages/rhankin/packages/trunk/knot/inst/3_1_yes_symmetric.svg"
          )

## This shows how to impose reflectional symmetry on
## k3_1, the trefoil knot.
library(knotR)
filename <- "3_1.svg"
a <- reader(filename)

Mver <- matrix(c(
    12,14,
    02,06,
    01,07,
    18,08,
    11,15,
    10,16,
    09,17
),ncol=2,byrow=TRUE)

Mrot <- matrix(c(
    12,06,18,
    13,07,01,
    14,08,02,
    03,15,09,
    04,16,10,
    05,17,11
    ),ncol=3,byrow=TRUE)


sym31 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        xver = c(4,13),
        Mrot = Mrot,
        )

a <- symmetrize(a,sym31)

ou31  <-
    matrix(c(
        15,6,
        9,18,
        3,12
        ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                symobj = sym31,
                ou   = ou31,
                prob=0,
                iterlim=100,print.level=2
#                control=list(trace=100,maxit=1000), # these arguments for optim()
#                useNLM=FALSE
                )


write_svg(jj,filename,safe=FALSE)
save(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "perko_B.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

sym_perko_B <- symmetry_object(a, xver=28 )
a <- symmetrize(a,sym_perko_B)
#knotplot2(a,lwd=1,text=TRUE,circ=FALSE,rainbow=TRUE)


ou_perko_B <- matrix(c(
    14,28,	
    27,11,
    06,25,
    24,17,
    08,23,
    22,09,
    02,21,
    18,04,
    16,07,
    10,15
), byrow=TRUE,ncol=2)

#knotplot(a,ou_perko_B)



jj <- knotoptim(filename,
                symobj = sym_perko_B,
                ou   = ou_perko_B,
                prob = 0,
#                iterlim=1000, print.level=2
                control=list(trace=100,maxit=10000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_6.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)


Mver <- matrix(c(
     22,23,
     21,1,
     12,10,
     13,9,
     2,20,
     19,3,
     4,18,
     5,17,
     14,8,
     6,16,
     7,15
),ncol=2,byrow=TRUE)

sym86 <- symmetry_object(a,Mver=Mver,xver=11)
a <- symmetrize(a,sym86)
#knotplot2(a,lwd=1,text=TRUE,rainbow=TRUE,circ=FALSE)

ou86 <- matrix(c(
     11,1,
     18,9,
     8,15,
     14,5,
     22,12,
     4,19,
     20,3,
     2,21

     
),ncol=2,byrow=TRUE)
#knotplot(a,ou86)

jj <-
  knotoptim(filename,
            symobj = sym86,
            ou   = ou86,
            prob = 0,
            iterlim=1000,print.level=2,hessian=FALSE
#            control=list(trace=100,maxit=2000), # these arguments for optim()
#            useNLM=FALSE
)

write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)


filename <- "9_29.svg"
a <- reader(filename)

Mrot929 <- 
    matrix(c(
        01,18,
        25,20,
        08,11,
        07,12,
        16,03,
        15,04,
        14,05,
        09,10,
        22,23,
        21,24,
        26,19,
        17,02,
        06,13
    ),ncol=2,byrow=TRUE)
                  
sym929 <-
    symmetry_object(a,Mrot=Mrot929,Mver=NULL, xver=26,center_crossing=TRUE)
a <- symmetrize(a,sym929)
#knotplot2(a,node=T,circ=33,seg=FALSE)
#knotplot2(a,node=F,circ=0,lwd=1,text=T)

ou929 <-
    matrix(
        c(
            02,21,
            13,03,
            04,11,
            24,06,
            07,17,
            16,09,
            10,23,
            22,14,
            18,25
            
 ),byrow=TRUE,ncol=2)
#knotplot(a,ou929)


jj <- knotoptim(filename,
                symobj = sym929,
                ou   = ou929,
                prob=0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
rm(list=ls())


filename <- "9_30.svg"
a <- reader(filename)
#knotplot2(a,node=T)

                  
sym930 <-
    symmetry_object(a,Mrot=NULL,Mver=NULL, xver=c(27,8),center_crossing=TRUE)
a <- symmetrize(a,sym930)

#knotplot2(a,node=T,circ=33,seg=TRUE)
#knotplot2(a,node=F,circ=0,lwd=1,text=T,rainbow=TRUE)

ou930 <-
    matrix(
        c(
            09,02,
            03,25,
            14,04,
            06,16,
            26,08,
            21,11,
            12,19,
            24,13,
            18,23
 ),byrow=TRUE,ncol=2)
#knotplot(a,ou930)

jj <- knotoptim(filename,
                symobj = sym930,
                ou   = ou930,
                prob=0,
                iterlim=1000,print.level=2
#                control=list(trace=100,maxit=10000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)


filename <- "9_40.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mver940 <- matrix(c(
    11,22,
    12,01,
    21,10,
    05,16,
    04,15,
    20,09,
    13,02,
    14,03,
    06,17,
    19,08,
    07,18
    ),byrow=TRUE,ncol=2)


Mhor940 <- matrix(c(
    12,06,
    05,13,
    11,07,
    04,14,
    21,19,
    22,18,
    01,17,
    10,08,
    15,03,
    16,02
    ),byrow=TRUE,ncol=2)


sym940 <-
    symmetry_object(a,Mver=Mver940,Mhor=Mhor940,xhor=c(9,20),
                    mcdonalds=TRUE,celtic=TRUE)

a <- symmetrize(a,sym940)
##knotplot2(a,node=TRUE)
##knotplot2(a,lwd=1,text=TRUE,rainbow=TRUE,circ=FALSE)


ou940 <- matrix(
    c(
        17,02,
        03,09,
        15,04,
        05,21,
        13,06,
        08,19,
        10,16,
        22,11,
        20,14
    ),byrow=TRUE,ncol=2)

#knotplot(a,ou940)

jj <- knotoptim(filename,
                symobj = sym940,
                ou   = ou940,
                prob = 0,
                iterlim=10000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "9_37.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)


ou937 <- matrix(c(  # alternating  
    18,02,
    03,16,
    24,05,
    07,22,
    20,09,
    15,19,
    10,14,
    13,26,
    27,11
), byrow=TRUE,ncol=2)

Mver937 <- matrix(c(
    11,17,
    27,01,
    12,16,
    26,02,
    10,18,
    13,15,
    09,19,
    20,08,
    21,07,
    06,22,
    05,23,
    25,03,
    24,04
), byrow=TRUE,ncol=2)


sym937 <- symmetry_object(a,Mver=Mver937,xver=c(14,28))
a <- symmetrize(a,sym937)
## knotplot2(a)
## knotplot2(a,text=TRUE,lwd=0,circ=FALSE,rainbow=TRUE)
##knotplot(a,ou937)

jj <- knotoptim(filename,
                symobj=sym937,
                ou   = ou937,
                prob=0,
                iterlim=50000, print.level=2
#                control=list(trace=100,maxit=1000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "k11a203.svg"
a <- reader(filename)

Mver <-
  matrix(c(
      12,24,
      23,13,
      22,14,
      11,1,
      21,15,
      10,2,
      16,20,
      9,3
  ),ncol=2,byrow=TRUE)

sym11 <- symmetry_object(a,Mver=Mver)

ou11 <- matrix(c(
    14,1,
    2,15,
    7,4,
    5,19,
    20,6,
    18,8,
    9,17,
    22,11,
    12,23,
    24,13,
    21,16
),byrow=TRUE,ncol=2)


sym11 <- symmetry_object(a, Mver=Mver)

jj <- knotoptim(filename,
                symobj = sym11,
                ou = ou11, 
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library("knotR")
library("hexSticker")

## Function knotplot_new() defined below is exactly the same as
## knotR:knotplot() except that the colour of the obscuring strand is
## different.

`knotplot_new` <- function(x, ou, gapwidth=1, n=100, lwd=8, add=FALSE, ...){
    if(inherits(x,'knot')){
      ou <- x$overunderobj
      x <- as.minobj(x)
    }
    stopifnot(is.sensible(ou,x))
    a <- as.inkscape(x)
    if(!add){
      plot(a,type='n',asp=1, axes=FALSE, xlab='', ylab='', ...)
    }

    b <- as.controlpoints(a)

    xy_thin  <- matrix(0,0,2)
    xy_thick <- matrix(0,0,2)
    for(i in seq_along(b)){  # loop over all Bezier segments
      tee <- seq(from=0, to=1, len=n)  
      overs <- ou[ou[,2]==i,1]  # strands that pass *over* strand i  (NB: might be empty!)
      for(j in overs){  # loop over strands j that pass over strand i; i is under, j is over
        jj <- bezier_intersect(b[[i]],b[[j]],'para') # jj: c(ess,tee)
        crosspoint <- jj[2]  # crosspoint parameter for the OVERstrand
        xy_thick <- rbind(xy_thick,bezier(b[[j]],tee=seq(from=crosspoint-0.2,to=crosspoint+0.2, length=n)),NA)
      }
      xy_thin <- rbind(xy_thin, bezier(b[[i]],tee=tee))
    } # 'i' loop closes

    points(xy_thin, type='l',lwd=lwd,              lend=1, ljoin=1,                ...)
    points(xy_thick,type='l',lwd=lwd*(1+gapwidth), lend=1, ljoin=1, col="#7733FF", ...)
    points(xy_thick,type='l',lwd=lwd,              lend=1, ljoin=1,                ...)

    return(invisible(xy_thin))
}


pdf(file="knotR_icon.pdf",bg="#7733FF")
par(mai=c(0,0,0,0))
knotplot_new(hexknot,lwd=15)
dev.off()

sticker("knotR_icon.pdf", package="knotR", p_size=18, s_x=1, s_y=1,
        s_width=0.9,asp=0.85, white_around_sticker=TRUE, h_fill="#7733FF",
        h_color="#000000", filename="knotR.png")

library(knotR)
filename <- "5_2.svg"
a <- reader(filename)

Mver <-  matrix(c(
    02,04,
    10,12,
    01,05,
    06,16,
    15,07,
    09,13,
    08,14
),ncol=2,byrow=TRUE)


sym52 <- symmetry_object(
    x    = a,
    Mver = Mver,
    xver = c(3,11)
    )

a <- symmetrize(a,sym52)

ou52 <-
  matrix(c(
      12,05,
      08,15,
      16,07,
      06,01,
      02,11
      ), ncol=2,byrow=TRUE)

jj <- knotoptim(filename,
                Mver = Mver,
                xver = c(3,11),
                ou   = ou52,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_34.svg"
a <- reader(filename)
##knotplot2(a,node=T)


Mver934 <-
  matrix(c(
      10,08,
      20,32,
      19,33,
      18,34,
      17,01,
      11,07,
      12,06,
      31,21,
      13,05,
      30,22,
      29,23,
      28,24,
      04,14,
      03,15,
      16,02,
      27,25
  ),byrow=TRUE,ncol=2)


sym934 <-
    symmetry_object(
        x    = a,
        Mver = Mver934,
        xver = c(9,26),
        mcdonalds=FALSE
        )
    
a <- symmetrize(a,sym934)
##knotplot2(a,circ=0,node=F,text=T,lwd=1,seg=F,rainbow=TRUE)


ou934  <-
  matrix(c(
      02,25,
      16,03,
      05,14,
      22,06,
      08,33,
      20,11,
      13,31,
      28,17,
      32,21
  ),byrow=TRUE,ncol=2)

knotplot(a,ou934)


#knotplot(a,ou934)

jj <- knotoptim(filename,
                symobj  = sym934,
                ou      = ou934,
                prob    = 0,
                iterlim = 1000, print.level=2
#                control=list(trace=100,maxit=1000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "product_knot.svg"

a <- reader(filename)
symprod <- symmetry_object(a,xver=c(9,17))      # no real symmetry, but force

ouprod <- matrix(c(
    01,07,
    06,02,
    03,09,
    08,05,
    10,14,
    16,11,
    13,17
),ncol=2,byrow=TRUE)


jj <- knotoptim(filename,
                symobj = symprod,
                ou   = ouprod,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "k11a43.svg"
a <- reader(filename)

Mver <- matrix(c(
    06,22,
    21,07,
    10,18,
    05,01,
    11,17,
    08,20,
    09,19,
    12,16,
    04,02,
    15,13
),ncol=2,byrow=TRUE)

sym43 <- symmetry_object(a,Mver=Mver,xver=c(3,14))

ou43 <- matrix(c(
    22,07,
    18,01,
    02,19,
    14,03,
    04,15,
    10,05,
    06,11,
    08,21,
    12,09,
    16,13,
    20,17
),ncol=2,byrow=TRUE)


jj <-
  knotoptim(filename,
            symobj = sym43,
            ou   = ou43,
            prob = 0,
            iterlim=1000,print.level=2,hessian=FALSE
#                control=list(trace=100,maxit=1000), # these arguments for optim()
#                useNLM=FALSE


)


write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_6_90deg_crossing.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)


Mver <- matrix(c(
     22,23,
     21,1,
     12,10,
     13,9,
     2,20,
     19,3,
     4,18,
     5,17,
     14,8,
     6,16,
     7,15
),ncol=2,byrow=TRUE)

sym86 <- symmetry_object(a,Mver=Mver,xver=11)
a <- symmetrize(a,sym86)
#knotplot2(a,lwd=1,text=TRUE,rainbow=TRUE,circ=FALSE)

ou86 <- matrix(c(
     11,1,
     18,9,
     8,15,
     14,5,
     22,12,
     4,19,
     20,3,
     2,21

     
),ncol=2,byrow=TRUE)
#knotplot(a,ou86)
w <- c(pot = 1,
      ang = 100,
      ben = 1,
      len = 1,
      mid = 1,
      clo = 1,
      swi = 1,
      con = 1,
      ncn = 1
      )

jj <-
  knotoptim(filename,weights=w,
            symobj = sym86,
            ou   = ou86,
            prob = 0,
            iterlim=1000,print.level=2,hessian=FALSE
#            control=list(trace=100,maxit=2000), # these arguments for optim()
#            useNLM=FALSE
)

write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_11.svg"
a <- reader(filename)
sym811 <- symmetry_object(a,Mver=NULL,xver=4)
a <- symmetrize(a,sym811)
#knotplot2(a,node=T)
#knotplot2(a,lwd=1,text=T,circ=F,rainbow=T)


ou811 <- matrix(c(
    22,09,
    10,21,
    20,11,
    07,19,
    17,06,
    12,16,
    15,02,
    03,13
),ncol=2,byrow=TRUE)


#knotplot(a,ou811)


jj <-
  knotoptim(filename,
            symobj = sym811,
            ou   = ou811,
            prob = 0,
            iterlim = 1000,print.level=2,hessian=FALSE
#            control=list(trace=100,maxit=1000), # these arguments for optim()
#            useNLM=FALSE
            )


write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

## For a complicted knot like this, the general idea is to specify the
## rotational symmetry first, for every node (here, rothex).  Then the
## mirror symmetry; here I specify the horizontal symmetry (hexMver)
## but see how only three nodes (18-16; 24-10; 11-23) are needed as
## the remaining horizontal and vertical mirror symmetry is a product
## of the sixfold rotational symmetry imposed by rothex.  We also need
## to enforce a single node (17) to be on the vertical axis---see how
## the first row of rothex then forces node 44 to be on the vertical
## axis as well; there is no need to have 17,44 as a row in hexMver.




library(knotR)
filename <- "hexknot3.svg"
a <- reader(filename)
jj <- c(-1,1)*350
#plot(jj,jj,asp=1)
#knotplot2(a,node=TRUE,add=TRUE)

rothex <- matrix(c(
    19,09,59,49,39,29,
    20,10,60,50,40,30,
    18,08,58,48,38,28,
    11,01,51,41,31,21,
    12,02,52,42,32,22,
    27,17,07,57,47,37,
    12,02,52,42,32,22,
    26,16,06,56,46,36,
    13,03,53,43,33,23,
    25,15,05,55,45,35,
    04,54,44,34,24,14
),byrow=TRUE,ncol=6)

hexMver <- matrix(c(

    20,18,
    27,11,
    12,26,
    13,25,
    24,14,
    12,26,
    21,17
    ),byrow=T,ncol=2)

#knotplot2(a,node=T)

symhex <- symmetry_object(a, Mrot=rothex,Mver=hexMver,
                          Mhor=NULL,
                          xver=c(19),xhor=c(4,34),
                          celtic=TRUE)

a <- symmetrize(a,symhex)
#knotplot2(a,node=T,circ=FALSE,add=TRUE,lwd=1,seg=F)


if(FALSE){
  abline(0,tan(pi/3),col='gray',lty=3)
  abline(0,-tan(pi/3),col='gray',lty=3)
  abline(0,tan(pi/6),col='gray',lty=3)
  abline(0,-tan(pi/6),col='gray',lty=3)
  abline(h=0,v=0,col='gray',lty=3)
}


#knotplot2(a,text=TRUE,node=FALSE,lwd=0.1,circ=F,add=TRUE)

ouhex <- matrix(c(

    08,01,   # 1
    15,04,  # 2
    02,17,  # 3
    18,11, # 4
    25,14, # 5
    12,27, # 6
    28,21, # 7
    35,24, # 8
    22,37, # 9    


    38, 31,
    45, 34,
    32, 47,
    48, 41,
    52, 07,
    05, 54,
    55, 44,
    42, 57,
    58, 51
    
),ncol=2,byrow=TRUE)

#knotplot(a,ouhex,gap=2)




jj <- knotoptim(filename,
                symobj = symhex,
                ou     = ouhex,
                prob   = 0,
#                iterlim=100, print.level=2
                control=list(trace=100,maxit=10000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "amphichiral15.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mver <- matrix(c(
    6,41,
    5,42,
    40,7,
    4,43,
    3,1
),ncol=2,byrow=TRUE)

symamp <- symmetry_object(a,Mver=Mver,xver=2)

a <- symmetrize(a,symamp)


# knotplot2(a,node=F,lwd=1)
#knotplot2(a,lwd=1,text=T,circ=F,rainbow=TRUE)

ouamp <- matrix(c(
     1,  13,
     8,   2,
     3,  40,
     4,  21,
    22,   5,    
    37,  21,
    19,  26,
    37,  28,
    20,  35,
    41,   7,
    33,  11,
    14,  43,
    27,  34,
    30,  39,
     9,  31
),ncol=2,byrow=TRUE)

#knotplot(a,ouamp,gap=15,lwd=10)


jj <-
  knotoptim(filename,
            symobj = symamp,
            ou   = ouamp,
            prob = 0,
            iterlim=1000,print.level=2,hessian=FALSE
#                control=list(trace=100,maxit=1000), # these arguments for optim()
#                useNLM=FALSE

)

write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "9_35.svg"
a <- reader(filename)

ou935 <- matrix(c(  # alternating  
    01,16,
    14,02,
    04,13,
    11,20,
    22,10,
    08,23,
    17,07,
    06,18,
    19,05
), byrow=TRUE,ncol=2)

Mver935 <- matrix(c(
    23,24,
    08,15,
    09,14,
    22,01,
    07,16,
    17,06
), byrow=TRUE,ncol=2)

Mhor935 <- matrix(c(
    23,11,
    07,19,
    17,05,
    08,20,
    22,10,
    09,21,
    24,12,
    16,04,
    06,18,
    15,03,
    01,13,
    14,02
), byrow=TRUE,ncol=2)

sym935 <- symmetry_object(a,Mver=Mver935,Mhor=Mhor935)



jj <- knotoptim(filename,
                symobj=sym935,
                ou   = ou935,
                prob=0,
                iterlim=10000, print.level=2
#                control=list(trace=100,maxit=1000), #these arguments for optim()
#               useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_27.svg"
a <- reader(filename)
#knotplot2(a,node=T)

Mver <- matrix(c(
    19,18,
    25,29,
    08,10,
    26,28
),ncol=2,byrow=TRUE)


sym927 <-
    symmetry_object(
        x    = a,
        xver = c(9,27),
        Mver = Mver
    )


a <- symmetrize(a,sym927)
##knotplot2(a,seg=T,node=T,circ=222)
##knotplot2(a,lwd=1,text=T,rainbow=TRUE,circ=F )


ou927  <-
    matrix(c(
        12,02,
        03,15,
        23,07,
        08,21,
        26,09,
        10,29,
        17,11,
        30,18,
        20,25
    ),byrow=TRUE,ncol=2)

##knotplot(a,ou927)

jj <- knotoptim(filename,
                symobj  = sym927,
                ou      = ou927,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

## This R script is a bit like trefoil_circles.R.  It plots (a
## projection of) 8_18 assuming that the strand is an elastica.  The
## constraints are: (1), strands cross at right angles; the strands
## exert a couple but no force on one another; (2), mirror symmetry
## about the vertical; (3), FOURfold rotational symmetry.  Constraint
## #1 implies that the strands are arcs of a circle, or straight
## lines.

## NB this file produces 8_18_circles.pdf, which is not production
## quality!  It needs to be tidied up in inkscape before anyone sees
## it.


circ <- function(x,y,r,start=0,finish=2*pi, ...){
  theta <- seq(from=start,to=finish,len=100)
  points(x+r*cos(theta),y+r*sin(theta),type="l",lwd=11, ...)
}

pdf(file="8_18_circles.pdf")
par(pty='s')
plot(NA,xlim=c(-4,4),ylim=c(-4,4),asp=1,axes=FALSE,xlab="",ylab="")
segments(x0=c(-1,1,1,-1),y0=c(1,1,-1,-1),x1=c(1,1,-1,-1),y1=c(1,-1,-1,1),lwd=11)

x  <- 1+sqrt(2)
r1 <- 2+sqrt(2)
r2 <- 1+sqrt(2)


circ(+1,-x,r1,pi/2,pi/4)
circ(-1,-x,r1,pi/2,3*pi/4)
circ(+1,+x,r1,-pi/2,-pi/4)
circ(-1,+x,r1,-pi/2,-3*pi/4)

circ(-x,1,r1,0,pi/4)
circ(-x,-1,r1,0,-pi/4)
circ(+x, 1,r1,3*pi/4,pi)
circ(+x,-1,r1,-3*pi/4,-pi)

circ(1+sqrt(2)/2,1+sqrt(2)/2,r2,-pi/4,3*pi/4)
circ(1+sqrt(2)/2,-(1+sqrt(2)/2),r2,-3*pi/4,pi/4)
circ(-(1+sqrt(2)/2),1+sqrt(2)/2,r2,pi/4,5*pi/4)
circ(-(1+sqrt(2)/2),-(1+sqrt(2)/2),r2,3*pi/4,7*pi/4)


dev.off()

library(knotR) 
filename <- "three_figure_eights.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mrot <- matrix(c(
    23,12,1,
    22,11,33,
    15,4,26,
    16,5,27,
    14,3,25,
    21,10,32,
    20,9,31,
    19,8,30,
    13,2,24,
    17,6,28,
    18,7,29
    ),ncol=3,byrow=TRUE)
sym38 <- symmetry_object(a, xver=24, Mrot=Mrot)
a <- symmetrize(a,sym38)
#knotplot2(a,node=T)
#knotplot2(a,node=F,lwd=1,text=T,rainbow=T,circ=F)

ou38 <- matrix(c(
    22,15,
    17,21,
    19,13,
    14,17,

    11,4,
    6,10,
    8,2,
    3,6,

    33,26,
    28,32,
    30,24,
    25,28


),ncol=2,byrow=TRUE)

#knotplot(a,ou38)
#stop()


# We will try and request that node 4 is on the vertical centreline.

jj <- knotoptim(filename,
                symobj = sym38,
                ou   = ou38,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_17.svg"
a <- reader(filename)
Mver <- NULL
#knotplot2(a,node=T)
#stop()
sym817 <- symmetry_object(a,Mver=Mver,xver=4)
a <- symmetrize(a,sym817)
#knotplot2(a,text=T,circ=F,lwd=1,rainbow=TRUE)

ou817 <- matrix(c(
    18,10,
    12,21,
    24,15,
    16,7,
    2,17,
    22,3,
    6,23,
    8,1
),ncol=2,byrow=TRUE)
#knotplot(a,ou817)

jj <-
  knotoptim(filename,
            symobj = sym817,
            ou   = ou817,
            prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=10000), useNLM=FALSE
)

write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR) 
filename <- "D16.svg"
a <- knotR::reader(filename)

Mrot <- matrix(c(
    40,15,30,05,20,35,10,25,
    26,01,16,31,06,21,36,11,
    13,28,03,18,33,08,23,38,
    14,29,04,19,34,09,24,39,
    27,02,17,32,07,22,37,12
),byrow=TRUE,ncol=8)

Mver <- matrix(c(
    26,14,
    39,01,
    13,27,
    12,28
    ),ncol=2,byrow=TRUE)

#knotplot2(a,node=T)

sym16 <- symmetry_object(a, xver=40, Mrot=Mrot, Mver=Mver)
a <- symmetrize(a,sym16)
knotplot2(a,node=F,width=F,text=T,lwd=1,rain=T,seg=T)
ou16 <- matrix(c(
    01,15,
    29,02,
    04,17,
    31,05,
    06,20,
    34,07,
    09,22,
    10,36,
    25,11,
    12,39,
    14,27,
    16,30,
    19,32,
    21,35,
    24,37,
    26,40
),ncol=2,byrow=TRUE)

# We will try and request that node 4 is on the vertical centreline.

jj <- knotoptim(filename,
                symobj = sym16,
                ou   = ou16,
                prob=0,
#               iterlim=100, print.level=2
               control=list(trace=100,maxit=20000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "3_1_alternative.svg"
a <- reader(filename)

Mver  <- matrix(c(
    05,10,
    04,09,
    01,06,
    07,02,
    03,08
    ),byrow=TRUE,ncol=2)


ou31a <-
    matrix(c(
        01,06,
        07,02,
        03,08
        ),byrow=TRUE,ncol=2)

sym31a <- symmetry_object(a, Mver=Mver,mcdonalds=TRUE)

jj <- knotoptim(filename,
                symobj = sym31a,
                ou   = ou31a,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)


filename <- "8_18.svg"
a <- reader(filename)
Mrot818 <-
    matrix(c(
        17,23,05,11,
        16,22,04,10,
        18,24,06,12,
        01,07,13,19,
        09,15,21,03,
        02,08,14,20
    ),ncol=4,byrow=TRUE)


Mver818 <- matrix(c(
    18,16,
    09,01,
    02,08
    ),byrow=TRUE,ncol=2)
                  
sym818 <-
    symmetry_object(a,Mrot=Mrot818,Mver=Mver818,xver=c(5,17),xhor=c(11,23))
a <- symmetrize(a,sym818)

ou818 <-
    matrix(
        c(
            16,01,
            02,09,
            20,03,
            04,13,
            22,07,
            08,15,
            10,19,
            14,21
 ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                symobj = sym818,
                ou   = ou818,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "k12a_0614.svg"
a <- reader(filename)

xver  <- c(10,23)

ouk12 <-
  matrix(c(
      15,1,  
      2,14,
      21,3,
      4,10,
      19,5,
      6,18,
      10,7,
      8,22,
      23,9,
      11,20,
      17,12,
      13,16
  ),byrow=TRUE,ncol=2)


symk11 <- symmetry_object(a, Mver=NULL, xver=xver)
a  <- symmetrize(as.minobj(a),symk11)

knotplot(a,ouk12)
stop()

jj <- knotoptim(filename,
                symobj = symk11,
                ou   = ouk11,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "9_49.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)



Mver949 <- matrix(c(
    27,1,
    11,17,
    12,16,
    10,18,
    26,2,
    19,9,
    20,8,
    13,15,
    7,21,
    25,3,
    24,4,
    6,22,
    5,23
), byrow=TRUE,ncol=2)



sym949 <-
  symmetry_object(
      a,
      Mver=Mver949,
      xver=c(14,28),
  )

a <- symmetrize(a,sym949)
#knotplot2(a)

##knotplot2(a,lwd=1,text=TRUE,rainbow=TRUE,circ=FALSE)


ou949 <- matrix(c(# nonalternating  
    18,2,
    3,16,
    5,24,
    14,7,
    21,8,
    10,19,
    27,11,
    13,26,
    22,15
), byrow=TRUE,ncol=2)


##knotplot(a,ou949)



jj <- knotoptim(filename,
                symobj=sym949,
                ou   = ou949,
                prob=0,
                iterlim=1000, print.level=2
#               control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_8.svg"
a <- reader(filename)

Mver <- matrix(c(
    NA,NA
),ncol=2,byrow=TRUE)

sym98 <-
    symmetry_object(
        x    = a,
        xver = 8,
        Mver = NULL
    )


a <- symmetrize(a,sym98)


ou98  <-
    matrix(c(
        24,10,
        22,02,
        03,20,
        19,05,
        06,17,
        13,07,
        08,15,
        11,23,
        16,12
    ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                symobj  = sym98,
                ou      = ou98,
                prob    = 0,
                iterlim = 1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "k11a179.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mver <-
  matrix(c(
  3,25,
  2,26,
  15,13,
  4,24,
  1,27,
  16,12,
  5,23,
  6,22,
  7,21,
  17,11,
  8,20,
  18,10,
  19,9
  ),ncol=2,byrow=TRUE)

symk11 <- symmetry_object(a,Mver=Mver,xver=c(14,28))
a <- symmetrize(a,symk11)
#knotplot2(a,text=TRUE,lwd=1,circ=FALSE,node=TRUE)



ouk11 <-
  matrix(c(
  25,14,
  13,27,
  23,12,
  11,21,
  20,9,
  8,18,
  17,6,
  2,16,
  15,4,
  28,24,
  5,1
  ),byrow=TRUE,ncol=2)
#knotplot(a,ouk11)



jj <- knotoptim(filename,
                symobj = symk11,
                ou   = ouk11,
                prob=0,
                iterlim=3000, print.level=2
#                control=list(trace=100,maxit=10000), # these arguments for optim()
#                useNLM=FALSE
                )



write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "7_7a.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mver <- matrix(c(
    1,7,
    28,8,
    27,9,
    6,2,
    21,15,
    20,16,
    19,17,
    26,10,
    25,11,
    24,12,
    5,3,
    22,14,
    23,13
    ),ncol=2,byrow=TRUE)

sym77a <- symmetry_object(a,Mver=Mver,xver=c(4,18))
a <- symmetrize(a,sym77a)
#knotplot2(a,text=T,lwd=1,circ=FALSE,rainbow=TRUE)
#stop()


ou77a <- matrix(c(
    10,15,
    4,13,
    15,3,
    22,27,
    6,22,
    24,5,
    2,7
    ),byrow=TRUE,ncol=2)

#knotplot(a,ou77a)


jj <- knotoptim(filename,
                symobj = sym77a,
                ou   = ou77a,
                prob = 0,
                iterlim=1000,print.level=2
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.R',filename))

library(knotR)
filename <- "9_20.svg"

a <- reader(filename)

sym920 <-
    symmetry_object(
        x    = a,
        xver = 27,
        mcdonalds=FALSE
    )

a <- symmetrize(a,sym920)

ou920  <-
    matrix(c(
        01, 23,
        14, 02,
        04, 13,
        21, 05,
        08, 18,
        19, 10,
        12, 20,
        16, 26,
        24, 15
        ),byrow=TRUE,ncol=2)

jj <- knotoptim(filename,
                symobj  = sym920,
                ou      = ou920,
                prob    = 0,
                iterlim = 10, print.level=2
#               control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_12.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

sym812 <- symmetry_object(a,Mver=NULL,xver=5)
a <- symmetrize(a,sym812)
#knotplot2(a,node=TRUE)
#knotplot2(a,text=TRUE,lwd=1,circ=FALSE,rainbow=TRUE)

ou812 <- matrix(c(
    18,2,
    3,16,
    13,5,
    6,10,
    22,8,
    9,21,
    20,14,
    15,19
),ncol=2,byrow=TRUE)

#knotplot(a,ou812)


jj <-
  knotoptim(filename,
            symobj = sym812,
            ou   = ou812,
            prob = 0,
            iterlim=1000,print.level=2,hessian=FALSE
            ## control=list(trace=100,maxit=1000), # these arguments for optim()
            ## useNLM=FALSE
 )

write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_3.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)
#stop()
Mver <- matrix(c(
     10,24,
     23,11,
     9,1,
     8,2,
     12,22,
     21,13,
     14,20,
     15,19,
     7,3,
     16,18,
     6,4
),ncol=2,byrow=TRUE)

sym83 <- symmetry_object(a,Mver=Mver,xver=c(5,17))
a <- symmetrize(a,sym83)
#knotplot2(a,lwd=1,text=TRUE,circ=FALSE,rainbow=TRUE)


ou83 <- matrix(c(
     11,24,
     23,12,
     13,22,
     21,14,
     3,20,
     18,4,
     7,17,
     15,8
),ncol=2,byrow=TRUE)

#knotplot(a,ou83)


jj <-
  knotoptim(filename,
            symobj = sym83,
            ou   = ou83,
            prob = 0,
            iterlim=1000,print.level=2,hessian=FALSE
#                control=list(trace=100,maxit=1000), # these arguments for optim()
#                useNLM=FALSE
)


write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "9_26.svg"
a <- reader(filename)

sym926 <- symmetry_object(a,celtic=FALSE,xver=27)
a <- symmetrize(a,sym926)

ou926 <- matrix(  # alternating
    c(
        02,18,
        20,04,
        06,21,
        17,07,
        08,26,
        15,10,
        11,24,
        23,13,
        25,16
    ), byrow=TRUE,ncol=2)

jj <- knotoptim(filename,
                symobj=sym926,
                ou   = ou926,
                prob=0,
                iterlim=1000,print.level=2
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

## This shows how to impose reflectional symmetry on
## k7_4
a <- reader("~/packages/rhankin/packages/trunk/knot/inst/7_4_experimental.svg")
knotplot(a,T,T,T,T,T)
## Now create a symmetry object (look at the knotplot(a) to see the
## nodes that are rotationally related, and also the nodes that are on
## the centreline)


Mver <- matrix(c( 4,10, 5,9, 13,1, 12,2, 6,8, 11,3 ),ncol=2,byrow=TRUE)
xver <-  c(7,14)   # nodes on centreline
Mhor <- matrix(c(05,12,04,11,13,06,14,07,01,08,10,03,09,02),ncol=2,byrow=TRUE)
ou  <-  matrix( c(1,11,9,2,4,8,11,4,4,14,13,6,7,11),byrow=TRUE,ncol=2)

jj <-
    knotoptim("~/packages/rhankin/packages/trunk/knot/inst/7_4_experimental.svg",
            Mver = Mver, xver = xver, Mhor=Mhor, ou=ou,
            iterlim=100,print.level=2,prob=0.4)
knotplot(jj,ever=T)
stop()






jjMhor <-
    matrix(c(
        05,12,
        04,11,
        13,06,
        14,07,
        01,08,
        10,03,
        09,02
        ),ncol=2,byrow=TRUE)

sym74 <- symmetry_object(a, Mver=jjMver, xver=jjv, Mhor=jjMhor)  
k74  <- symmetrize(as.minobj(a),sym74)
knotplot(k74,T,T,T,T,T,circ=500)  #OK, it looks terrible

## Function symmetrize_LR() creates a symmetrized knot:

mii <- make_minsymvec_from_minobj(k74,sym74)
pii <- make_minobj_from_minsymvec(mii,sym74)

ou74 <-
    matrix(
        c(
            1,11,
            9,2,
            4,8,
            11,4,
            4,14,
            13,6,
            7,11
        ),byrow=TRUE,ncol=2)


knotplot2(k74, ou74)

# now optimize; first define an objective function:

`objective_function` <- function(m){
    badness(make_minobj_from_minsymvec(m, sym74))
}

o <- nlm(objective_function,mii,iterlim=100,print.level=2)

optknot74 <-  knot(make_minobj_from_minsymvec(o$estimate,sym74),ou74,sym74)
knotplot(optknot74,T,T,T,T,circ=1900)

stop()

optknot74 <- 
structure(list(minsymvec = structure(c(-75.546314030929, -475.06583696795, 
-465.844466363306, -20.6856618628832, 239.608437707992, 96.404394286175, 
25.0513723094883, -281.465469748823, -474.194552647129, -346.556021453004, 
254.747783104722, 84.7070522941651, 85.103708533547, 145.080368039035
), .Names = c("handle_A4", "handle_A5", "handle_A13", "handle_A14", 
"handle_A18", "handle_A19", "handle_A27", "node4", "node5", "node13", 
"node18", "node19", "node27", "node28"), class = "minsymvec"), 
    overunderobj = structure(c(1, 9, 4, 11, 4, 13, 7, 11, 2, 
    8, 4, 14, 6, 11), .Dim = c(7L, 2L)), symobj = structure(list(
        Mver = structure(c(4, 5, 13, 10, 9, 1), .Dim = c(3L, 
        2L)), xver = c(7, 14), Mhor = structure(c(5, 4, 13, 14, 
        1, 10, 9, 12, 11, 6, 7, 8, 3, 2), .Dim = c(7L, 2L)), 
        xhor = NULL, Mrot = NULL, mcdonalds = FALSE, indep = structure(c(FALSE, 
        FALSE, FALSE, TRUE, TRUE, FALSE, FALSE, FALSE, FALSE, 
        FALSE, FALSE, FALSE, TRUE, TRUE, FALSE, FALSE, FALSE, 
        TRUE, TRUE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, 
        FALSE, TRUE, FALSE, FALSE, FALSE, FALSE, TRUE, TRUE, 
        FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE, 
        FALSE, FALSE, FALSE, FALSE, TRUE, TRUE, FALSE, FALSE, 
        FALSE, FALSE, FALSE, FALSE, FALSE, TRUE, TRUE), .Names = c("handle_A1", 
        "handle_A2", "handle_A3", "handle_A4", "handle_A5", "handle_A6", 
        "handle_A7", "handle_A8", "handle_A9", "handle_A10", 
        "handle_A11", "handle_A12", "handle_A13", "handle_A14", 
        "handle_A15", "handle_A16", "handle_A17", "handle_A18", 
        "handle_A19", "handle_A20", "handle_A21", "handle_A22", 
        "handle_A23", "handle_A24", "handle_A25", "handle_A26", 
        "handle_A27", "handle_A28", "node1", "node2", "node3", 
        "node4", "node5", "node6", "node7", "node8", "node9", 
        "node10", "node11", "node12", "node13", "node14", "node15", 
        "node16", "node17", "node18", "node19", "node20", "node21", 
        "node22", "node23", "node24", "node25", "node26", "node27", 
        "node28"))), .Names = c("Mver", "xver", "Mhor", "xhor", 
    "Mrot", "mcdonalds", "indep"))), .Names = c("minsymvec", 
"overunderobj", "symobj"), class = "knot")

library(knotR)

filename <- "9_32.svg"
a <- reader(filename)
#knotplot2(a,node=T)


ou932 <- matrix(c(  # alternating  
    02,25,
    23,04,	
    05,32,
    17,07,
    09,29,
    20,10,
    12,22,
    28,14,
    30,18
), byrow=TRUE,ncol=2)
#knotplot2(a,text=TRUE,lwd=1,rain=TRUE,circ=FALSE)
#knotplot(a,ou932)

sym932 <- symmetry_object(a,Mver=NULL,xver=c(27))
#knotplot2(symmetrize(a,sym932))

jj <- knotoptim(filename,
                symobj=sym932,
                ou   = ou932,
                prob=0,
                iterlim=10000,print.level=2
#                control=list(trace=100,maxit=10000), # these arguments for optim()
#                useNLM=FALSE

                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
a <- reader("celtic.svg")
knotplot(a,ev=T)

Mver <- matrix(c(
    10,1,
    11,2,
    12,3,
    5,14,
    16,7,
    17,8,
    18,9,
    4,13,
    6,15,
    4,13
    ),ncol=2,byrow=TRUE)

Mhor <- matrix(c(
    10,18,
    11,17,
    12,16,
    6,4,
    15,13,
    1,9,
    2,8,
    3,7

 ),ncol=2,byrow=TRUE)
xhor <- c(5,14)
ou <- matrix(c(
    1,7,
    10,1,
    1,13,
    5,1,
    16,5,
    13,16,
    16,10,
    7,16,
    4,15,
    14,7,
    10,14,
    6,13,
    10,6,
    13,4,
    4,10,
    7,4,
    15,1
    ),ncol=2,byrow=TRUE)


s <- symmetry_object(a, Mver=Mver,Mhor=Mhor,xhor=xhor, celtic=TRUE, mcdonalds=TRUE)

a <- as.minobj(symmetrize(a,s))

mi <- make_minsymvec_from_minobj(a,s) 

knotplot(make_minobj_from_minsymvec(mi,s))  # fails


jj <- 
knotoptim("celtic.svg",
          Mver=Mver,Mhor=Mhor,xhor=xhor, ou=ou,
                    celtic=TRUE, mcdonalds=TRUE,
          print.level=2,
          prob=0.1)

library(knotR)

filename <- "9_48.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)


Mver948 <- matrix(c(
    27,1,
    11,17,
    12,16,
    10,18,
    26,2,
    19,9,
    13,15,
    25,3,
    24,4,
    20,8,
    7,21,
    6,22,
    23,5
), byrow=TRUE,ncol=2)




sym948 <-
  symmetry_object(
      a,
      Mver=Mver948,
      xver=c(14,28),
  )

a <- symmetrize(a,sym948)
##knotplot2(a)
##knotplot2(a,lwd=1,text=TRUE,rainbow=TRUE,circ=FALSE)


ou948 <- matrix(c(  # nonalternating  
    18,2,
    3,16,
    6,23,
    21,8,
    9,15,
    10,19,
    27,11,
    13,26,
    14,20
), byrow=TRUE,ncol=2)


##knotplot(a,ou948)


jj <- knotoptim(filename,
                symobj=sym948,
                ou   = ou948,
                prob=0,
                iterlim=10000,print.level=2
#               control=list(trace=100,maxit=1000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "ochiai.svg"
ou   <-
    matrix(c(
        07,01,
        01,20,
        02,09,
        22,03,
        16,04,
        05,18,
        25,06,
        08,21,
        10,14,
        19,11,
        13,20,
        15,23,
        24,19
    ),ncol=2,byrow=TRUE)

jj <- knotoptim(filename,
                xver = 6,
                ou = ou,
                prob=0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=1000), # these arguments for optim()
#                useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "7_3.svg"
a <- reader(filename)

#knotplot2(a,node=TRUE)

Mver  <- matrix(c(
      22,20,
      09,07,
      10,06,
      11,05,
      23,19,
      12,04,
      24,18,
      03,13,
      02,14,
      25,17,
      15,01,
      26,16
    ),byrow=TRUE,ncol=2)

sym73 <- symmetry_object(a, Mver=Mver, xver=c(8,21))
a <- symmetrize(a,sym73)
#knotplot2(a)
#knotplot2(a,text=TRUE,lwd=1,circ=FALSE,rainbow=TRUE)

ou73 <-
    matrix(c(
    08,20,
    19,05,
    01,16,
    15,02,
    04,13,
    12,24,
    23,09
        ),byrow=TRUE,ncol=2)

#knotplot(a,ou73)


jj <- knotoptim(filename,
                symobj = sym73,
                ou   = ou73,
                prob=0,
                iterlim=1000,print.level=2
#                control=list(trace=100,maxit=1000), # these arguments for optim()
#                useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

stop() 





## Function symmetrize_LR() creates a symmetrized knot:
k7_3_symmetrized <- symmetrize(as.minobj(k7_3), sym_7_3)

knotplot(k7_3_symmetrized,T,T,T,T,T,circ=500)  #OK, it looks terrible


mii <- make_minsymvec_from_minobj(k7_3_symmetrized,sym_7_3)
pii <- make_minobj_from_minsymvec(mii,sym_7_3)





knotplot2(k7_3_symmetrized, ou_7_3)

# now optimize; first define an objective function:

`objective_function` <- function(m){
    badness(make_minobj_from_minsymvec(m, sym_7_3),prob=0.1)
}

o <- nlm(objective_function,mii,iterlim=200,print.level=2)


opt_7_3 <-  make_minobj_from_minsymvec(o$estimate,sym_7_3)
knotplot(opt_7_3,T,T,T,T,circ=1900)

library(knotR)
filename <- "9_17.svg"

a <- reader(filename)
Mver <- matrix(c(
    25,01,
    08,18,
    07,19,
    09,17,
    10,16,
    24,02,
    05,21,
    23,03,
    22,04,
    11,15,
    06,20,
    12,14
),ncol=2,byrow=TRUE)


sym917 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        xver = c(13,26),
        mcdonalds=FALSE
    )

a <- symmetrize(a,sym917)

ou917  <-
  matrix(c(
      02,18,
      16,03,
      04,21,
      22,05,
      06,23,
      12,07,
      09,25,
      24,11,
      20,15
        ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                symobj  = sym917,
                ou      = ou917,
                prob    = 0,
                weights=c(1,5,1,1,1,1,1,1,1),
#                iterlim = 10000,print.level=2
                control=list(trace=100,maxit=10000), useNLM=FALSE
            )


write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "12n838.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

Mver <- matrix(c(
    37,01,
    24,14,
    23,15,
    22,16,
    36,02,
    35,03,
    13,25,
    12,26,
    27,11,
    28,10,
    34,04,
    05,33,
    29,09,
    30,08,
    21,17,
    32,06,
    31,07,
    20,18
),ncol=2,byrow=TRUE)

sym828 <- symmetry_object(a,Mver=Mver,xver=c(19,38))
a <- symmetrize(a,sym828)
#knotplot2(a,node=TRUE)


knotplot2(a,text=TRUE,lwd=1,circ=FALSE,rainbow=TRUE)

ou828 <- matrix(c(  # nonalternating!
    02,15,
    11,04,
    05,34,
    33,06,
    07,18,
    17,10,
    27,12,
    14,25,
    32,21,
    22,29,
    37,24,
    28,35
),ncol=2,byrow=TRUE)

##knotplot(a,ou828,gap=10)

jj <-
  knotoptim(filename,
            symobj = sym828,
            ou   = ou828,
            prob = 0,
            iterlim=1000, print.level=2,
#            control=list(trace=100,maxit=100000), useNLM=FALSE
            )

write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "8_9.svg"
a <- reader(filename)

sym89 <- symmetry_object(a,xver=7)

a <- symmetrize(a,sym89)
#knotplot2(a,node=T,circ=333)
#knotplot2(a,node=FALSE,lwd=1,text=TRUE,circ=FALSE,rainbow=TRUE)



ou89 <- matrix(c(
    17,06,
    05,15,
    14,03,
    02,18,
    09,01,
    23,11,
    10,21,
    19,09
),ncol=2,byrow=TRUE)

#knotplot(a,ou89)

jj <-
  knotoptim(filename,
            symobj = sym89,
            ou     = ou89,
            prob   = 0,
                iterlim = 1000, print.level=2
#                control=list(trace=2,maxit=10000), # these arguments for optim()
#                useNLM=FALSE
)


write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "9_31.svg"
a <- reader(filename)

ou931 <- matrix(c(  # alternating  
    14,01,
    02,16,
    12,04,
    05,18,
    10,06,
    07,21,
    22,09,
    19,11,
    17,13
), byrow=TRUE,ncol=2)

Mver931 <- matrix(c(
    07,15,
    08,14,
    21,01,
    20,02,
    06,16,
    09,13,
    05,17,
    10,12,
    18,04,
    19,03
), byrow=TRUE,ncol=2)

sym931 <- symmetry_object(a,Mver=Mver931,xver=c(11,22))
#knotplot2(symmetrize(a,sym931))

jj <- knotoptim(filename,
                symobj=sym931,
                ou   = ou931,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "fourloops.svg"
a <- reader(filename)


Mrot <- matrix(c(
    16,4,8,12,
    15,3,7,11,
    1,5,9,13,
    14,2,6,10
    ),byrow=TRUE,ncol=4)
    

    

Mver <- matrix(c(
    01,15,
    14,02
),ncol=2,byrow=TRUE)


symfour <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        Mrot = Mrot,
        xver = c(8,16),
        xhor = c(12,4),
        )

as <- symmetrize(a,symfour)

oufour  <-
    matrix(c(
        02,15,
        06,03,
        10,07,
        14,11
        ),byrow=TRUE,ncol=2)

knotplot(as,oufour,gap=10)

jj <- knotoptim(filename,
                symobj = symfour,
                ou   = oufour,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "triloop.svg"

outri <- matrix(
    c(
        01,06,
        12,02,
        03,18,
        10,04,
        05,16,
        08,13,
        19,09,
        17,11,
        15,20
	) , byrow=TRUE,ncol=2)



## Now create a symmetry object (look at the knotplot(a) to see the
## nodes that are rotationally related, and also the nodes that are on
## the centreline)
Mrottri <-
  rbind(
      c(15,01,08),
      c(16,02,09),
      c(10,17,03),
      c(04,11,18),
      c(05,12,19),
      c(20,06,13),
      c(21,07,14)
      )

Mvertri <- 
    matrix(
        c(
            20,21,
            15,05,
            04,16,
            14,06,
            19,01,
            03,17,
            18,02,
            08,12,
            13,07
            ),
        byrow=TRUE,ncol=2
        )


jj <- knotoptim(filename,
                Mrot = Mrottri,
                Mver = Mvertri,
                xver = 10,
                ou   = outri,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)


filename <- "6_3.svg"
a <- reader(filename)

sym63 <- symmetry_object(a,xver=13)

a <- symmetrize(a,sym63)

ou63 <- matrix(c(
    10,17,
    01,12,
    08,03,
    04,14,
    15,05,
    13,09
    ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                xver = 13,
                ou   = ou63,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "k11a1.svg"
a <- reader(filename)

sym11 <- symmetry_object(a,xver=4)
a <- symmetrize(a,sym11)

ou11 <- matrix(c(
    2,  23,
    25,  3,
    4,  29,
    12,  5,
    6,  17,
    15,  7,
    9,  31,
    30, 11,
    18, 13,
    28, 20,
    21, 26
),byrow=TRUE,ncol=2)

jj <- knotoptim(filename,
                symobj = sym11,
                ou = ou11, prob=0,
#                iterlim=10000, print.level=2
                control=list(trace=100,maxit=1000), # these arguments for optim()
                useNLM=FALSE
                )


write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "6_2.svg"

Mver <- 
  matrix(c(
      01,07,
      15,08,
      06,02,
      14,09,
      10,13,
      05,03,
      11,12
  ),ncol=2,byrow=TRUE)
     
ou62 <- matrix(c(
    07,02,
    03,09,
    10,14,
    05,11,
    13,04,
    15,06
    ),byrow=TRUE,ncol=2)


jj <- knotoptim(filename,
                Mver = Mver,
                xver = 4,
                ou   = ou62,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "9_43.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)
#knotplot2(a,lwd=1,rainbow=TRUE,circ=FALSE,text=TRUE)


ou943 <- matrix(c(  # nonalternating
    1,14,
    17,2,
    10,3,
    4,9,
    5,18,
    20,6,
    13,19,
    8,12,
    14,5
), byrow=TRUE,ncol=2)




sym943 <- symmetry_object(a,xver=20)
a <- symmetrize(a,sym943)


##knotplot2(a)
##knotplot2(a,lwd=1,text=TRUE,circ=FALSE,rain=TRUE)
##knotplot(a,ou942)

jj <- knotoptim(filename,
                symobj=sym943,
                ou   = ou943,
                prob=0,
                iterlim=10000, print.level=2
#                control=list(trace=100,maxit=1000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "9_44.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)
#knotplot2(a,lwd=1,rainbow=TRUE,circ=FALSE,text=TRUE)


ou944 <- matrix(c(  # nonalternating
    8,2,
    20,10,
    11,17,
    16,21,
    3,15,
    22,14,
    13,5,
    23,7,
    4,21
), byrow=TRUE,ncol=2)


sym944 <- symmetry_object(a,xver=18)
a <- symmetrize(a,sym944)

##knotplot2(a)
##knotplot2(a,lwd=1,text=TRUE,circ=FALSE,rain=TRUE)
##knotplot(a,ou944)

jj <- knotoptim(filename,
                symobj=sym944,
                ou   = ou944,
                prob=0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "perko_A.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)


Mver <- matrix(c(
    23,25,
    12,08,
    13,07,
    14,06,
    22,26,
    21,27,
    28,20,
    11,09,
    01,19,
    02,18,
    03,17,
    15,05,
    04,16
    ),byrow=TRUE, ncol=2)

ou_perko_A <-
  matrix(c(
    26,08,
    09,27,
    21,28,
    01,11,
    15,02,
    05,16,
    19,06,
    10,20,
    12,22,
    23,13
    ),byrow=TRUE, ncol=2)



sym_perko_A <- symmetry_object(a,
                               Mver=Mver,
                               xver=c(10,24)
                               )

a <- symmetrize(a,sym_perko_A)
#knotplot2(a,lwd=1,text=1,circ=F,rainbow=TRUE)
#knotplot(a,ou_perko_A)
#stop()




jj <- knotoptim(filename,
                symobj = sym_perko_A,
                ou   = ou_perko_A,
                prob = 0,
                iterlim=300, print.level=2
#                control=list(trace=100,maxit=337), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.R',filename))

library(knotR)
filename <- "unknot.svg"
jj <- knotoptim(filename,
                Mver = matrix(c(2,4,1,5), byrow=TRUE,ncol=2),
                xver = 3,
                Mrot = cbind(3,4,5,1,2),
                ou   = NULL,
                prob=0,
                iterlim=100,print.level=2
                )


write_svg(jj,filename)
stop() 

library(knotR)
filename <- "8_13.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)

sym813 <- symmetry_object(a,Mver=NULL,xver=26)
a <- symmetrize(a,sym813)

#knotplot2(a,node=T)
#knotplot2(a,node=F,lwd=1,circ=F,text=T,rainbow=T)

ou813 <- matrix(c(
    26,15,
    16,02,
    10,19,
    20,07,
    06,23,
    24,11,
    03,25,
    12,04
),ncol=2,byrow=TRUE)

#knotplot(a,ou813)


jj <-
  knotoptim(filename,
            symobj = sym813,
            ou   = ou813,
            prob = 0,
            iterlim=1000, print.level=2
#           control=list(trace=100,maxit=5000), useNLM=FALSE
)

write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "T20.svg"

a <- reader(filename)
symT20 <-
    symmetry_object(
        x    = a,
        xver = c(32,28),
        mcdonalds=FALSE
    )




ouT20  <-
    matrix(c(
        01, 06,
        07, 02,
        03, 17,
        05, 08,
        18, 04,
        20, 10,
        11, 21,
        22, 12,
        26, 14,
        15, 27
        ),byrow=TRUE,ncol=2)

jj <- knotoptim(filename,
                symobj  = symT20,
                ou      = ouT20,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_16.svg"



a <- reader(filename)

Mver <- matrix(c(
    11,22,
    12,01,
    19,08,
    14,03,
    21,10,
    13,02,
    20,09,
    15,04,
    18,07,
    05,16,
    17,06
),ncol=2,byrow=TRUE)

sym916 <-
    symmetry_object(
        x    = a,
        Mver = Mver,
        xver = NULL,
        mcdonalds=TRUE
    )

a <- symmetrize(a,sym916)

ou916  <-
  matrix(c(
      22,11,
      08,02,
      03,09,
      10,04,
      05,16,
      17,06,
      13,19,
      20,14,
      15,21
        ),byrow=TRUE,ncol=2)

jj <- knotoptim(filename,
                symobj  = sym916,
                ou      = ou916,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "8_19b.svg"
a <- reader(filename)
Mrot819 <-
    matrix(c(
        17,23,05,11,
        16,22,04,10,
        18,24,06,12,
        01,07,13,19,
        09,15,21,03,
        02,08,14,20
    ),ncol=4,byrow=TRUE)


Mver819 <- matrix(c(
    18,16,
    09,01,
    02,08
    ),byrow=TRUE,ncol=2)
                  
sym819 <-
    symmetry_object(a,Mrot=Mrot819,Mver=Mver819,xver=c(5,17),xhor=c(11,23))
a <- symmetrize(a,sym819)

ou819 <-
    matrix(
        c(
            16,01,
            09,02,
            03,20,
            04,13,
            22,07,
            15,08,
            10,19,
            21,14
 ),byrow=TRUE,ncol=2)

#knotplot2(a,lwd=1,text=TRUE,circ=0)
#knotplot(a,ou=ou819,lwd=16,gap=2)

jj <- knotoptim(filename,
                symobj = sym819,
                ou   = ou819,
                prob = 0,
                iterlim=10, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)

filename <- "7_7.svg"
a <- reader(filename)

Mver <- matrix(c(
    06,11,
    07,10,
    16,01,
    05,12,
    08,09,
    04,13,
    15,02,
    14,03
    ),ncol=2,byrow=TRUE)


ou77 <- matrix(c(
    01,12,
    10,02,
    04,14,
    09,05,
    13,09,
    06,17,
    16,08
    ),byrow=TRUE,ncol=2)

sym77 <- symmetry_object(a, Mver=Mver,xver=17)   

jj <- knotoptim(filename,
                symobj = sym77,
                ou   = ou77,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))



stop() 




## Function symmetrize_LR() creates a symmetrized knot:
k77 <- symmetrize(as.minobj(a), sym77)

knotplot(k77,T,T,T,T,T,circ=500)  #OK, it looks terrible

mii <- make_minsymvec_from_minobj(k77,sym77)
pii <- make_minobj_from_minsymvec(mii,sym77)




knotplot2(k77,ou77)


# now optimize; first define an objective function:

`objective_function` <- function(m){
    badness(make_minobj_from_minsymvec(m, sym77))
}

o <- nlm(objective_function,mii,iterlim=30,print.level=2)

opt77 <-  make_minobj_from_minsymvec(o$estimate,sym77)
knotplot(opt77,T,T,T,T,circ=1900)

## This R batch file creates "knots_to_8crossings.pdf" and
## "compare_crossing_angles.pdf" for use by jma_knot.tex

filename1 <- "knots_to_8crossings.pdf"
filename2 <- "compare_crossing_angles.pdf"
filename3 <- "two_trefoil_knots.pdf"

do1 <- TRUE  # change to FALSE to save time
do2 <- TRUE
do3 <- TRUE

library("knotR")

if(do1){
a <-
  list(
      unknot, k3_1,  k4_1,  k5_1,  k5_2,  k6_1 ,
      k6_2  , k6_3,  k7_1,  k7_2,  k7_3,  k7_4 ,
      k7_5  , k7_6,  k7_7,  k8_1,  k8_2,  k8_3 ,
      k8_4  , k8_5,  k8_6,  k8_7,  k8_8,  k8_9 ,
      k8_10 , k8_11, k8_12, k8_13, k8_14, k8_15,
      k8_16 , k8_17, k8_18, k8_19, k8_20, k8_21
  )

leg <- list(
    expression(0),
    expression(3[1]),
    expression(4[1]),
    expression(5[1]),
    expression(5[2]),
    expression(6[1]),
    expression(6[2]),
    expression(6[3]),
    expression(7[1]),
    expression(7[2]),
    expression(7[3]),
    expression(7[4]),
    expression(7[5]),
    expression(7[6]),
    expression(7[7]),
    expression(8[1]),
    expression(8[2]),
    expression(8[3]),
    expression(8[4]),
    expression(8[5]),
    expression(8[6]),
    expression(8[7]),
    expression(8[8]),
    expression(8[9]),
    expression(8[10]),
    expression(8[11]),
    expression(8[12]),
    expression(8[13]),
    expression(8[14]),
    expression(8[15]),
    expression(8[16]),
    expression(8[17]),
    expression(8[18]),
    expression(8[19]),
    expression(8[20]),
    expression(8[21])
)
    
`knotplot_bespoke` <- function(x, ou, gapwidth=1, n=100, lwd=8, add=FALSE, ext=0.2, ...){
    if(inherits(x,'knot')){
      ou <- x$overunderobj
      x <- as.minobj(x)
    }
    stopifnot(is.sensible(ou,x))
    a <- as.inkscape(x)
    if(!add){
      plot(a,type='n',asp=1, axes=FALSE, xlab='', ylab='', ...)
    }

    b <- as.controlpoints(a)

    xy_thin  <- matrix(0,0,2)
    xy_thick <- matrix(0,0,2)
    for(i in seq_along(b)){  # loop over all Bezier segments
      tee <- seq(from=0, to=1, len=n)  
      overs <- ou[ou[,2]==i,1]  # strands that pass *over* strand i  (NB: might be empty!)
      for(j in overs){  # loop over strands j that pass over strand i; i is under, j is over
        jj <- bezier_intersect(b[[i]],b[[j]],'para') # jj: c(ess,tee)
        crosspoint <- jj[2]  # crosspoint parameter for the OVERstrand
        xy_thick <- rbind(xy_thick,bezier(b[[j]],tee=seq(from=crosspoint-ext,to=crosspoint+ext, length=n)),NA)
      }
      xy_thin <- rbind(xy_thin, bezier(b[[i]],tee=tee))
    } # 'i' loop closes

    points(xy_thin, type='l',lwd=lwd,              lend=1, ljoin=1,              ...)
    points(xy_thick,type='l',lwd=lwd*(1+gapwidth*0.5), lend=1, ljoin=1, col="white", ...)
    points(xy_thick,type='l',lwd=lwd,              lend=1, ljoin=1,              ...)

    return(invisible(xy_thin))
}


b <- lapply(a,overunder)

pdf(file=filename1,width=40,height=40)
par(pty='m')
plot(1:10,xlim=c(0,10000),ylim=c(0,10000),asp=1,type='n',axes=FALSE,xlab='',ylab='')


xs <- 1600  # spacing between knots (x)
ys <- 1600  # spacing between knots (y)

xstart <- -300 # offset for whole diagram (x)
ystart <- +700 # offset for whole diagram (y)

xtext <- -350
ytext <- 450

for(i in 1:6){
    for(j in 1:6){
        n <- (i-1)*6 + j
        xoff <-    j * xs + xstart
        yoff <- (6-i)* ys + ystart
        k <- as.inkscape(a[[n]])
        k[,2] <- k[,2] - mean(k[,2])
        k <- sweep(k,2,c(xoff,yoff),"+")
        print(n)
        if(n==18){# k8_3
            knotplot_bespoke(k,b[[n]],add=TRUE,lwd=7,ext=0.3,gap=3)
        } else {
            knotplot_bespoke(k,b[[n]],add=TRUE,lwd=7,gap=3)
        }
        text(xoff+xtext,yoff+ytext,leg[[n]],
             cex=3)
    }
}

dev.off()
} # if(do1) closes

# Now create "compare_crossing_angles.pdf"



if(do2){
a <-
  list(
      k8_3 , k8_3_90deg_crossing,
      k8_5 , k8_5_90deg_crossing,
      k8_6 , k8_6_90deg_crossing,
      k8_11, k8_11_90deg_crossing
  )

leg <- list(  # legend
    expression(8[ 3]), expression(8[3]),
    expression(8[ 5]), expression(8[5]),
    expression(8[ 6]), expression(8[6]),
    expression(8[11]), expression(8[11])
)
    

b <- lapply(a,overunder)

pdf(file=filename2,width=6,height=4)
par(pty='m',
oma = c(0, 0, 0, 0), # two rows of text at the outer left and bottom margin
mar = c(0, 0, 0, 0), # space for one row of text at ticks and to separate plots
mgp = c(0, 0, 0))
plot(NA,xlim=c(400,2600),ylim=c(6000,7500),asp=1,type='n',axes=FALSE,xlab='',ylab='')

xs <- 900  # spacing between knots (x)
ys <- 1200  # spacing between knots (y)

xstart <- +100 # offset for whole diagram (x)
ystart <- +700 # offset for whole diagram (y)

xtext <- -350
ytext <- 450

for(i in 1:1){
    for(j in 1:2){
        n <- (i-1)*2 + j
        xoff <-    j * xs + xstart
        yoff <- (6-i)* ys + ystart
        k <- as.inkscape(a[[n]])
        k[,2] <- k[,2] - mean(k[,2])
        k <- sweep(k,2,c(xoff,yoff),"+")
        print(n)
        knotplot(k,b[[n]],add=TRUE,lwd=2.5,gap=3)
        if(FALSE){text(xoff+xtext,yoff+ytext,leg[[n]], cex=3)}
    }
}

dev.off()
}

if(do3){
    a <- list(k3_1)
    leg <- list( expression(3[1]))  # legend
    b <- lapply(a,overunder)

    pdf(file=filename3,width=6,height=4)
    par(pty='m',
        oma = c(0, 0, 0, 0), # two rows of text at the outer left and bottom margin
        mar = c(0, 0, 0, 0), # space for one row of text at ticks and to separate plots
        mgp = c(0, 0, 0))
    plot(NA,xlim=c(400,2600),ylim=c(6000,7500),asp=1,type='n',axes=FALSE,xlab='',ylab='')
    
    xs <- 900  # spacing between knots (x)
    ys <- 1200  # spacing between knots (y)
    
    xstart <- +100 # offset for whole diagram (x)
    ystart <- +700 # offset for whole diagram (y)
    
    xtext <- -350
    ytext <- 450
    
    i <- 1
    j <- 1
    
    n <- (i-1)*2 + j
    xoff <-    j * xs + xstart
    yoff <- (6-i)* ys + ystart
    k <- as.inkscape(a[[n]])
    k[,2] <- k[,2] - mean(k[,2])
    k <- sweep(k,2,c(xoff,yoff),"+")
    print(n)
    knotplot(k,b[[n]],add=TRUE,lwd=2.5,gap=3)

    `arc` <- function(x,y,r,theta1,theta2,rot=0,center=FALSE, ...){
        n <- 100
        jj <- matrix(c(cos(rot),sin(rot),-sin(rot),cos(rot)),2,2) %*% c(x,y)
        x <- jj[1]
        y <- jj[2] 
        if(center){ points(x,y, ...) } 
        theta <- seq(from=theta1-rot,to=theta2-rot,len=n)
        cbind(x+r*sin(theta),y+r*cos(theta))
    }
   
small <- 0.05
    
    `f` <- function(angle,o,...){
        if(o==1){
            arc(x=0, y=-2-2/sqrt(3), theta1 =   0, theta2 =   pi/12, r=sqrt(6)+sqrt(2), rot=angle)
        } else if(o==2){
            arc(x=0, y=+2-2/sqrt(3), theta1 =  0, theta2 = 7*pi/12, r=sqrt(6)-sqrt(2), rot=angle)
        } else if(o==3){
            arc(x=0, y=-2-2/sqrt(3), theta1 = pi/12-small, theta2 =   pi/12+small, r=sqrt(6)+sqrt(2), rot=angle)
        } else if(o==4){
            arc(x=0, y=-2-2/sqrt(3), theta1 =    -pi/12, theta2 =   0, r=sqrt(6)+sqrt(2), rot=angle)
        } else if(o==5){
            arc(x=0, y=+2-2/sqrt(3), theta1 =  -7*pi/12, theta2 = 0, r=sqrt(6)-sqrt(2), rot=angle)
        } else {
            stop()
        }
    }
    x0 <- 2170
    y0 <- 6720
    scale <- 300
    for(angle in c(0,2,4)*pi/3){
        points(sweep(scale*f(angle,o=1),2,c(x0,y0),"+"),type="l",lwd=2.5,col="red")
        points(sweep(scale*f(angle,o=2),2,c(x0,y0),"+"),type="l",lwd=2.5,col="orange")
        points(sweep(scale*f(angle,o=3),2,c(x0,y0),"+"),type="l",lwd=2.5*4,col="yellow")
        points(sweep(scale*f(angle,o=4),2,c(x0,y0),"+"),type="l",lwd=2.5,col="green")
        points(sweep(scale*f(angle,o=5),2,c(x0,y0),"+"),type="l",lwd=2.5,col="blue")
    }
    
    dev.off()

    
}

library(knotR)
filename <- "8_16.svg"
a <- reader(filename)
#knotplot2(a,node=TRUE)



Mver <- matrix(c(
    09,25,
    08,26,
    07,01,
    24,10,
    16,18,
    23,11,
    15,19,
    06,02,
    12,22,
    15,19,
    14,20,
    13,21,
    05,03
),ncol=2,byrow=TRUE)

sym816 <- symmetry_object(a,Mver=Mver,xver=c(4,17))
a <- symmetrize(a,sym816)


#knotplot2(a,lwd=1,text=T,circ=F,rainbow=TRUE)


ou816 <- matrix(c(
    25,10,
    11,18,
    23,12,
    13,06,
    07,16,
    17,24,
    19,02,
    03,22
),ncol=2,byrow=TRUE)

#knotplot(a,ou816)


jj <-
  knotoptim(filename,
            symobj = sym816,
            ou   = ou816,
            prob = 0,
                iterlim=10000, print.level=2
#                control=list(trace=100,maxit=10000), useNLM=FALSE
)


write_svg(jj, filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "7_4.svg"
a <- reader(filename)

Mhor <-
  matrix(c(
      06,12,
      07,11,
      05,13,
      17,01,
      16,02,
      08,10,
      14,04,
      15,03
  ),ncol=2,byrow=TRUE)

xhor  <- c(9,18)    # nodes on centreline

Mver <-
  matrix(c(
      16,07,
      15,06,
      08,17,
      14,05,
      09,18,
      04,13,
      10,01,
      03,12,
      02,11
  ),ncol=2,byrow=TRUE)


sym74 <- symmetry_object(a, Mver=Mver, xhor=xhor, Mhor=Mhor,mcdonalds=TRUE,celtic=TRUE)
k74  <- symmetrize(as.minobj(a),sym74)

ou74 <- matrix(c(
    1, 13,
    11, 2,
    4, 10,
    14, 5,
    6, 18,
    17, 8,
    9, 15
), ncol=2,byrow=TRUE)


jj <- knotoptim(filename,
                symobj = sym74,
                ou   = ou74,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

library(knotR)
filename <- "9_14.svg"
a <- reader(filename)



sym914 <-
    symmetry_object(
        x    = a,
        Mver = NULL,
        xver = 23
        )
    
a <- symmetrize(a,sym914)


ou914  <-
  matrix(c(
      17,1,
      2,15,
      14,4,
      5,12,
      11,18,
      23,10,
      8,19,
      21,7,
      19,22
  ),byrow=TRUE,ncol=2)

knotplot(a,ou914)


jj <- knotoptim(filename,
                symobj  = sym914,
                ou      = ou914,
                prob = 0,
                iterlim=1000, print.level=2
#                control=list(trace=100,maxit=100000), useNLM=FALSE
                )

write_svg(jj,filename,safe=FALSE)
dput(jj,file=sub('.svg','.S',filename))

% -*- mode: noweb; noweb-default-code-mode: R-mode; -*-
\documentclass[nojss]{jss}
\usepackage{dsfont}
\usepackage{bbm}
\usepackage{amsfonts}
\usepackage{wasysym}
\usepackage{amssymb}

%\title{Knot Theory in R}
%\subtitle{The \pkg{knotR} package}
%\author{Robin K. S. Hankin}
%\maketitle


\author{Robin K. S. Hankin\\The University of Stirling}
\title{Visually pleasing knot projections in \proglang{R}}
%\VignetteIndexEntry{A vignette for the knot package}
%% for pretty printing and a nice hypersummary also set:
\Plainauthor{Robin K. S. Hankin}
\Plaintitle{Visually pleasing knot projections in R}
\Shorttitle{Visually pleasing knot projections in \proglang{R}}

%% an abstract and keywords
\Abstract{

To cite this work in publications, use \cite{hankin2023}.

In this short article I introduce the \pkg{knotR} package, which
creates two dimensional knot diagrams optimized for visual appearance.
The \pkg{knotR} package is a systematic \proglang{R}-centric suite of software
for the creation of production-quality artwork of knot diagrams.

}

\Keywords{Knot theory, R}
\Plainkeywords{Knot theory, R}

%% publication information
%% NOTE: This needs to filled out ONLY IF THE PAPER WAS ACCEPTED.
%% If it was not (yet) accepted, leave them commented.
%% \Volume{13}
%% \Issue{9}
%% \Month{September}
%% \Year{2004}
%% \Submitdate{2004-09-29}
%% \Acceptdate{2004-09-29}
%% \Repository{https://github.com/RobinHankin/knotR} %% this line for Tragula

%% The address of (at least) one author should be given
%% in the following format:
\Address{
  Robin K. S. Hankin\\%\orcid{https://orcid.org/0000-0001-5982-0415}\\
  The University of Stirling\\
  Scotland
}
%% It is also possible to add a telephone and fax number
%% before the e-mail in the following format:
%% Telephone: +43/1/31336-5053
%% Fax: +43/1/31336-734

%% for those who use Sweave please include the following line (with % symbols):
%% need no \usepackage{Sweave.sty}

%% end of declarations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

<<setup,echo=FALSE,print=FALSE>>=
ignore <- require(knotR)
@ 


\SweaveOpts{}
\begin{document}


\section{Introduction}
A \emph{mathematical knot} is a smooth, unoriented embedding of a
circle~$\mathbb{S}^1$ into~$\mathbb{R}^3$~\citep{manturov2004}.  Two
knots are said to be equivalent if one can be continuously deformed in
to the other; if so, there is a
homeomorphism~$h\colon\mathbb{R}^3\longrightarrow\mathbb{R}^3$ which
takes one embedded circle to the other.

It is common to present a knot using diagrams such as
Figure~\ref{knot_table}, in which a two-dimensional projection of the
knot is given with broken lines indicating where one strand passes
over another.

\begin{figure}[h]
  \centering
  \includegraphics[width=10cm]{1280px-Knot_table.png}
  \caption{A table of prime knots up \label{knot_table} to seven
    crossings, labels following~\citet{alexander1926}.  Image taken
    from~\citet{wikipedia_knot_theory}.}
\end{figure}

Consider Figure~\ref{knot_table} from an \ae sthetic perspective; the
diagrams are representative of those available under a free license.
However, these diagrams are not suitable for high-quality artwork such
as posters: they are not vectorized.  Many of the underlying knots
possess a line of symmetry (at least, the diagrams do if the breaks
are ignored), which is not present in the visual representation.
Also, several of the strands cross at acute angles.  The diagram for
knot~$7_3$, for example, contains ugly kinks and abrupt changes of
curvature.

Such considerations suggest that knot diagrams might be produced by
minimization of some objective function that quantifies the visual
inelegance of a knot diagram.  The precise nature of such an objective
function is, of course, a subjective choice but one might require the
following desiderata:

\begin{itemize}
\item Curvature to be as uniform as possible
\item Strands to cross at right angles
\item Crossing points to be separate from one another
\item Any symmetry present in the knot should be enforced exactly, and
  be visually apparent
\end{itemize}

Knot diagrams may be created using vectorized graphics software such
as inkscape~\citep{kirsanov2009}: one specifies a sequence of control
points, then interpolates between these points to create a knot diagram
with the appropriate topology.  One way of smoothly interpolating
between specified points is Bezier curves~\citep{olsen2014}.  A Bezier
curve is a visually pleasing polynomial path that can be used to
specify the path of a knot projection.

The package presented here allows one to specify a knot in terms of
its Bezier control points within inkscape, import the object into R,
and then to use numerical optimization techniques to improve the
visual appearance of the knot.

\section{The package in use}

In this section, I give workflows for creating two simple knots:
firstly~$7_6$, followed by the figure-of-eight knot~$4_1$ which
requires imposition of symmetry constraints.

The first step is to create a closed curve in inkscape that shows the
rough outline of the knot~(Figure~\ref{screenshot_inkscape_7_6} shows
a screenshot of \code{7_6_first_draft.svg}, supplied with the
package).  Note that this file contains only the knot {\em path}; the
over and under information is to be added later.

Here, knot paths are required to have Bezier handles that are
symmetrically placed with regard to nodes.  Although radius of
curvature is not necessarily matched at either side of a node, visual
continuity of the strand is ensured.  In the diagram, strand crossing
points are far from nodes, as this ensures visual continuity of
strands at crossing points, especially the understrand.

\begin{figure}[h]
  \centering
    \includegraphics[width=10cm]{screenshot_inkscape_7_6.png}
\caption{Screenshot of inkscape\label{screenshot_inkscape_7_6} setup
  for knot~$7_6$.  Nodes are shown as squares, handles as small
  circles, symmetrically placed on either side of nodes}
\end{figure}

The knot shown in Figure~\ref{screenshot_inkscape_7_6} is clearly
suboptimal: even though the nodes are connected by Bezier curves which
are individually smooth, the path as a whole is ugly and unattractive
as its path has unsightly regions where the radius of curvature
changes abruptly.

Although it is possible in principle to improve the visual appearance
of the knot path by hand in inkscape, this is a surprisingly difficult
and frustrating task.  In order to remedy the flaws of the diagram
using an automated system, we first read the \code{.svg} file into R
using the \code{reader()} function:

<<use_reader_k76>>=
k76 <- reader(system.file("7_6_first_draft.svg",package="knotR"))
head(k76)
@ 

Object~\code{k76} is stored as an object of class \code{inkscape}: a
two-column matrix with rows corresponding to the node and handle
positions of the inkscape path.  This representation has a certain
amount of redundancy as knot paths have handles which are
symmetrically placed with respect to nodes; also, the first node is
the same as the last for the loop is closed.  The package can coerce
inkscape objects to other forms, specifically \code{minobj} objects,
which contain no redundancy (the position of each node, as well as one
of the handles, is stored); or \code{controlpoints} objects, which
allow for easy construction of Bezier interpolation between nodes.

\begin{figure}[htbp]
  \begin{center}
<<7_6_rough,fig=TRUE>>=
par(oma=c(0, 0, 0, 0))
par(mar=c(0, 0, 0, 0))
par(plt=c(0, 1, 0, 1))
k76_rough <- reader(system.file("7_6_first_draft.svg",package="knotR"))
knotplot2(k76_rough, seg=TRUE)
@
\caption{The \emph{path} of \label{7_6_rough} knot~$7_6$, showing
  Bezier control points.  Coloured circles have a radius proportional
  to the curvature (that is, the reciprocal of the radius of
  curvature) along the strand}
  \end{center}
\end{figure}


\begin{figure}[!tbp]
  \centering
<<fig=TRUE,print=FALSE,echo=FALSE,height=4>>=
par(oma=c(0, 0, 0, 0))
par(mar=c(0, 0, 0, 0))
par(plt=c(0, 1, 0, 1))
par(pty='m')

knotplot2(k7_6,text=TRUE,lwd=1,circ=0,rainbow=TRUE)
@ 
\caption{Knot~$7_6$ with strands numbered \label{k76_strands} to guide
creation of over and under information} \end{figure}

To beautify it we need to specify a function of the path that
quantifies its displeasingness, and then minimize this objective
function using numerical methods.

Two examples of desiderata for such an objective function might be to
keep the strands crossing at right angles, and the overall bending
energy.  These are evaluated in the package by functions
\code{total_crossing_angle_badness()} and~\code{total_bending_energy()}
respectively:

<<k76_desiderata>>=
b <- as.controlpoints(k76_rough)
total_crossing_angle_badness(b)
total_bending_energy(b)
@ 

The knots supplied in the package minimize a weighted sum of these and
other badnesses\footnote{Function \code{badness()} includes various
``housekeeping'' badnesses which are used to make sure that the
minimum found by \code{nlm()} is topologically identical to the
starting configuration.  Function
\code{non\_crossing\_strand\_close\_approach\_badness()}, for example,
makes non-crossing strands ``repel'' one another so as not to
introduce spurious intersections.}, as evaluated by function
\code{badness()}:

<<k76_rough_badness>>=
badness(k76_rough)
@ 

This function may be minimized by numerical optimization:

\begin{Schunk}
\begin{Sinput}
> o <- nlm(badness, as.knotvec(k76_rough))
> k7_6 <- as.minobj(o$estimate)
> badness(k7_6)
\end{Sinput}
\begin{Soutput}
  [1] 3.550152
\end{Soutput}
\end{Schunk}

(the above takes about an hour of CPU time: it is optimizing function
of~64 real variables, and the objective function takes a few seconds
to evaluate).  However, the result is much nicer (Figure~\ref{7_6}).

\begin{figure}[!tbp]
  \centering
<<k76_knotplot2,fig=TRUE,print=FALSE,echo=FALSE>>=
knotplot2(k7_6)
@ 
\caption{Knot $7_6$, post-optimization\label{7_6}}
\end{figure}
   
To specify the senses of the knot's\ %---------------------------------'
crossings, we create an overunder object which is a two-column matrix:

<<k76_overunder>>=
ou76 <- matrix(c(
    12,01,
    02,11,
    07,03,
    04,15,
    16,06,
    14,08,
    10,13
    ),byrow=TRUE,ncol=2)
@ 

With reference to Figure~\ref{k76_strands}, each row of \code{ou76}
corresponds to a crossing; the first element gives the overstrand and
the second the understrand; thus strand~12 passes over strand~1,
strand~2 passes over strand~11, and so on. The result is shown in
figure~\ref{76_overunder}.
  
\begin{figure}[!tbp]
  \centering
<<fig=TRUE,print=FALSE,echo=FALSE>>=
knotplot(k7_6,ou76)
@ 
\caption{Knot $7_6$, post-optimization with breaks indicating
  \label{76_overunder}  underpassing strands}
\end{figure}


\subsection{Symmetry}

Many of the knots in Figure~\ref{knot_table} have an axis of symmetry,
or possess rotational symmetry.  The package has the ability to impose
symmetry relations on knots, and to optimize the resulting symmetrical
knot.  Minimizing the badness is not entirely straightforward on
account of the induced redundancy, which is characterized using a
symmetry object specific to the knot under consideration.  However,
symmetry constraints do reduce the dimensionality of the optimization
problem.

I will consider the figure-of-eight knot~$4_1$ as an example.  Using
Figure~\ref{four_figure_8_knots}, top left, as reference, the
appropriate symmetry object is defined as follows:

<<setup_figure_eight_symmetry_object>>=
fig8 <- reader(system.file("4_1_first_draft.svg",package="knotR"))
Mver8 <- matrix(c(
    02,03,
    09,07,
    05,11,
    10,06
    ),ncol=2,byrow=TRUE)

sym8 <- symmetry_object(fig8, Mver=Mver8, xver=8)
@ 

(Matrix \code{Mver8} specifies that nodes~2 and~3 are symmetric, as
are nodes~9 and~7, and so on; \code{xver=8} forces node~8 to be on the
axis of symmetry).  The results are shown in
Figure~\ref{four_figure_8_knots}.

\begin{figure}[!tbp]
  \centering
<<four_figure_eight_knots,fig=TRUE,print=FALSE,echo=FALSE>>=
par(oma=c(0, 0, 0, 0))
par(mar=c(0, 0, 0, 0))
par(plt=c(0, 1, 0, 1))
par(pty='m')
plot(NULL,xlim=c(-600,2200),ylim=c(-600,2200),asp=1,axes=FALSE)

offx <- 1400
offy <- 1500

overunder_fig8 <- 
  matrix(c(
      05,10,
      08,13,
      01,06,
      11,02
      ),ncol=2,byrow=TRUE)

jj <- sweep(as.inkscape(fig8),2,c(0,offy),"+")
knotplot2(jj,add=TRUE,node=TRUE,lwd=3,circ=0) # top left

fig8_symmetrized <- symmetrize(fig8,sym8)
jj <- sweep(as.inkscape(fig8_symmetrized),2,c(offx,offy),"+")
knotplot2(jj,add=TRUE,node=FALSE,width=TRUE)  # top right

jj <- sweep(as.inkscape(k4_1),2,c(0,0),"+")
knotplot2(jj,add=TRUE,node=FALSE,width=TRUE)  # lower left

jj <- sweep(as.inkscape(k4_1),2,c(offx,0),"+")
knotplot(jj,overunder_fig8,add=TRUE)          # lower right

@ 
\caption{Figure eight knots drawn using different plotting methods.
  top left, knot path with node numbers shown in order to facilitate
    \label{four_figure_8_knots} definition of the symmetry object; top
    right, result of symmetrizing the rough path; lower left, the
    optimized knot with imposed vertical symmetry, with curvature
    plotted; lower right, knot plotted with overstrand and understrand
    indicated using line breaks}
\end{figure}

  
\subsection{Rotational symmetry}

Consider knot~$5_1$. This knot has fivefold rotational symmetry, in
addition to a vertical line of symmetry.  The package includes
functionality to impose appropriate symmetry constraints. Using
Figure~\ref{k5_1_twoknots} as reference, we have:

\begin{figure}[htbp]
  \begin{center}
<<k5_1,fig=TRUE>>=
knotplot2(k5_1,node=TRUE,width=FALSE)
@
\caption{Knot $5_1$ \label{k5_1_twoknots} shown with node numbers}
  \end{center}
\end{figure}

<<setup_symmetry_k5_1>>=
sym51 <- symmetry_object(k5_1,
                         Mver = cbind(11,13),
                         xver = c(2,12),
                         Mrot = rbind(
                             c(12,04,16,08,20),
                             c(13,05,17,09,01),
                             c(11,03,15,07,19),
                             c(02,14,06,18,10)
                         ))
@ 

Thus, using the same notation as before, nodes~11 and~13 are
symmetrical about the vertical axis, nodes~2 and~12 are on the
vertical axis.  The \code{Mrot} argument specifies sets of nodes that
map to themselves under rotation.  The top line of \code{Mrot}
indicates that nodes 12,4,16, 8, and~20 are concyclic.  An example of
a rotationally symmetric knot is given in Figure~\ref{orn20}.

\section{Conclusions and further work}

The \pkg{knot} package allows the user to create rough diagrams of
knots using the inkscape suite of software, and subsequently polish up
such diagrams in terms of a customizable objective function using
numerical optimization techniques.  Further work might include
functionality to deal with links.


\clearpage
\section{Gallery}

There now follows a selection of pleasing knot diagrams taken from
datasets provided with the package.

\begin{figure}[htbp]
  \begin{center}
<<perko_A_and_B,fig=TRUE,width=5,height=3.2>>=
par(oma=c(0, 0, 0, 0))
par(mar=c(0, 0, 0, 0))
par(plt=c(0, 1, 0, 1))
par(pty='m')
plot(NULL,xlim=c(-700,2200),ylim=c(-1800,200),asp=1,box=FALSE)

jjA <- as.inkscape(perko_A)*1.7
jjB <- as.inkscape(perko_B)*1.7

oA <- perko_A$overunder
oB <- perko_B$overunder

knotplot(jjA,ou=oA,add=TRUE,lwd=4)
jjB <- sweep(as.inkscape(jjB),2,c(1500,-600),"+")
knotplot(jjB,ou=oB,add=TRUE,lwd=4)
@ 
\caption{Two representations of knot~$10_{125}$, known as the 
\label{perko_AB}  Perko Pair}
  \end{center}
\end{figure}


\begin{figure}[htbp]
  \begin{center}
<<ornamental,fig=TRUE>>=
par(oma=c(0, 0, 0, 0))
par(mar=c(0, 0, 0, 0))
par(plt=c(0, 1, 0, 1))
par(pty='m')
knotplot(ornamental20)
@ 
\caption{An ornamental knot exhibiting fivefold
  rotational \label{orn20} symmetry; note the absence of mirror symmetry}
  \end{center}
\end{figure}

\begin{figure}[htbp]
  \begin{center}
<<10123,fig=TRUE>>=
par(oma=c(0, 0, 0, 0))
par(mar=c(0, 0, 0, 0))
par(plt=c(0, 1, 0, 1))
par(pty='m')
knotplot(k10_123)
@ 
\caption{Knot $10_{123}$, exhibiting fivefold symmetry}
  \end{center}
\end{figure}

\begin{figure}[htbp]
  \begin{center}
<<alleightcrossingknots,echo=FALSE,fig=TRUE,width=5,height=10>>=
par(oma=c(0, 0, 0, 0))
par(mar=c(0, 0, 0, 0))
par(plt=c(0, 1, 0, 1))
par(pty='m')

a <-
    list(k8_1, k8_2, k8_3,
         k8_4, k8_5, k8_6,
         k8_7, k8_8, k8_9,
         k8_10, k8_11, k8_12,
         k8_13, k8_14, k8_15,
         k8_16, k8_17, k8_18,
         k8_19, k8_20, k8_21)

b <- lapply(a,overunder)

plot(1:10,xlim=c(0,6000),ylim=c(0,12000),asp=1,type='n',axes=F,xlab='',ylab='')

xs <- 1600
ys <- 1600

for(i in 1:3){
    for(j in 1:7){
        n <- (i-1)*7 + j
        xoff <- i*xs
        yoff <- j*ys
        k <- as.inkscape(a[[n]])
        k[,2] <- k[,2] - mean(k[,2])
        k <- sweep(k,2,c(xoff,yoff),"+")
        knotplot(k,b[[n]],add=TRUE,lwd=2)
    }
}
@ 
\caption{All prime eight-crossing knots, following \label{all8} Rolfsen}
  \end{center}
\end{figure}


\bibliography{knot}

\end{document}
 
